		.title	X680x0 System Information Version 2.19

version:	.reg	'2.19'
date:		.reg	'1997/09/29'


# symbols
#	__LIBC__	LIBCincludet@Cgp.
#	__CRLF__	sR[hCR,LFɂ(w莞LF).
#	__PRINT_SI_VER__
#			sĩo[W񍐂.
#	__STOP_TIMER_C__
#			processor performancevTimer-C~(lp).
#	__SHORT_LOOP__	processor performancevɒZ[vgp.


* Include File -------------------------------- *

	.ifdef	__LIBC__
		.include	si_libc.mac
	.else
		.include	doscall.mac
		.include	iocscall.mac
		.include	scsicall.mac
		.include	fefunc.mac
	.endif


* Control Code -------------------------------- *

BS:		.equ	$08
LF:		.equ	$0a
CR:		.equ	$0d

	.ifdef	__CRLF__
CRLF:		.reg	CR,LF
	.else
CRLF:		.reg	LF
	.endif


* Fixed Number -------------------------------- *

RTS_CODE:	.equ	$4e75
RTE_CODE:	.equ	$4e73

STDERR:		.equ	2

WAIT_COLOR:	.equ	1			;F(ύX\)
MEMSIZE_LEN:	.equ	6			;strlen("262144"):256MB
LONG_OPT_MAX:	.equ	7+1			;"-f-","--"͊܂܂Ȃ(+1͖NUL)
		.fail	LONG_OPT_MAX.and.1	;Kł邱
STACK_SIZE:	.equ	12288
		.fail	STACK_SIZE<8192


* IOCS Work ----------------------------------- *

ROMCNT:		.equ	$cb8
MPUTYPE:	.equ	$cbc

_HIMEM:		.equ	$f8
_HIMEM_GETSIZE:	.equ	3
_HIMEM_VERSION:	.equ	5

ROMVER_V1_00:	.equ	$10_870318
ROMVER_V1_00P:	.equ	$10_870507
ROMVER_XVI:	.equ	$11_910111
ROMVER_XVI_C:	.equ	$12_911124
ROMVER_030:	.equ	$13_921127


* I/O Address --------------------------------- *

;̓xN^ԍŁAxN^AhX4{lȂ̂Œӂ邱ƁI
ILLEGAL_VEC:	.equ	$04
FLINE_VEC:	.equ	$0b
PROTVIO_VEC:	.equ	$0d
TRAP14_VEC:	.equ	$2e
TIMERA_VEC:	.equ	$4d
TIMERB_VEC:	.equ	$48
*TIMERC_VEC:	.equ	$45
TIMERD_VEC:	.equ	$44
*VDISP_VEC:	.equ	$46
HSYNC_VEC:	.equ	$4f
RASTER_VEC:	.equ	$4e
OPM_VEC:	.equ	$43
ALARM_VEC:	.equ	$40
*EXPON_VEC:	.equ	$41
*POWSW_VEC:	.equ	$42
PRINTER_VEC:	.equ	$63
SPRIOUS_VEC:	.equ	$18

MFP:		.equ	$e88000
~MFP_IERA:	.equ	$07
~MFP_IERB:	.equ	$09
~MFP_IMRA:	.equ	$13
~MFP_IMRB:	.equ	$15
~MFP_TBCR:	.equ	$1b
~MFP_TCDCR:	.equ	$1d
~MFP_TBDR:	.equ	$21
~MFP_TCDR:	.equ	$23
~MFP_TDDR:	.equ	$25

DMAC_CH0:	.equ	$e84000
DMAC_CH1:	.equ	DMAC_CH0+$40
DMAC_CH2:	.equ	DMAC_CH0+$80
DMAC_CH3:	.equ	DMAC_CH0+$c0
~DMAC_CSR:	.equ	$00
~DMAC_CER:	.equ	$01
~DMAC_DCR:	.equ	$04
~DMAC_OCR:	.equ	$05
~DMAC_SCR:	.equ	$06
~DMAC_CCR:	.equ	$07
~DMAC_MTC:	.equ	$0a
~DMAC_MAR:	.equ	$0c
~DMAC_DAR:	.equ	$14
~DMAC_MFC:	.equ	$29
~DMAC_CPR:	.equ	$2d
~DMAC_DFC:	.equ	$31

RTC:		.equ	$e8a000
~RTC_1SEC:	.equ	$01
~RTC_MODE:	.equ	$1b
~RTC_RESET:	.equ	$1f

SYS_P4:		.equ	$e8e007			;Key Ctrl
SYS_P6:		.equ	$e8e00b			;CPU Type/CPU Clock
SYS_P7:		.equ	$e8e00d			;SRAM Write En/Dis

JOYSTICK1:	.equ	$e9a001

IOC_STATUS:	.equ	$e9c001

IOFPU1:		.equ	$e9e000
IOFPU2:		.equ	$e9e080

TS6BGA_PCMCTRL:	.equ	$e9e211

FAX_IO:		.equ	$eaf900
MIDI1_IO:	.equ	$eafa00
MIDI2_IO:	.equ	$eafa10
PARA1_IO:	.equ	$eafb00
PARA2_IO:	.equ	$eafb10
GPIB_IO:	.equ	$eafe00

MU_TOP:		.equ	$ecc000
MU_STAT:	.equ	$ecc091
MU_OPNREG:	.equ	$ecc0c1
MU_OPNST2:	.equ	$ecc0c3

POLY1_IO:	.equ	$eff800
POLY2_IO:	.equ	$eff880

PSX_IO1:	.equ	$efff00
PSX_IO2:	.equ	$efff20

RS_IO1:		.equ	$eafc00
RS_IO2:		.equ	$eafc10
RS_IO3:		.equ	$eafc20
RS_IO4:		.equ	$eafc30

NEPTUNE_IO1:	.equ	$ece000
NEPTUNE_IO2:	.equ	$ece400


* SRAM/ROM Address ---------------------------- *

SRAM:		.equ	$ed0000
SRAM_USEMODE:	.equ	$ed002d
SRAM_ONTIME:	.equ	$ed0040
SRAM_POWOFF:	.equ	$ed0044
SRAM_SCSI_ID:	.equ	$ed0070
SRAM_ASKA_ID:	.equ	$ed00f4
SRAM_ASKA_ADR:	.equ	$ed00f8
SRAM_ASKA_BUS:	.equ	$ed00fc
SRAM_PROG:	.equ	$ed0100
SRAM_END:	.equ	$ed4000
SRAM_MAX:	.equ	$edffff

SCSIEX_ID:	.equ	$ea0044
MACH2_IO:	.equ	$ea00e0

SCSIROM:	.equ	$fc0000
SCSIEXROM:	.equ	$ea0020

SCSIIN_ID:	.equ	$fc0024


* Macro --------------------------------------- *

PUSH:		.macro	regs
		movem.l	regs,-(sp)
		.endm
POP:		.macro	regs
		movem.l	(sp)+,regs
		.endm

STRCPY:		.macro	_s,_d
		.local	loop
loop:		move.b	(_s)+,(_d)+
		bne	loop
		subq.l	#1,_d
		.endm

STRCPY_CRLF:	.macro	_d
	.ifdef	__CRLF__
		move.b	#CR,(_d)+
	.endif
		move.b	#LF,(_d)+
		clr.b	(_d)
		.endm

RTC_WAIT:	.macro
		nop
		tas.b	(JOYSTICK1)
		nop
		tas.b	(JOYSTICK1)
		nop
		.endm

SRAM_WRITE_ENABLE:	.macro
		move.b	#$31,(SYS_P7)
		.endm
SRAM_WRITE_DISABLE:	.macro
		clr.b	(SYS_P7)
		.endm

; Ԃɍ킹.
; Cxxxxxn͐ɓ삵Ȃ.(X^bN)
; Sił͎gĂȂ̂ŖȂ(


FPACK2:		.macro	callno
		move.w	#callno,(FEnum,a6)
		bsr	FEcall
		.endm


* Offset Table -------------------------------- *

		.offset	0

reg_save:	.ds.l	4
trap14_save:	.ds.l	1
trap8_save:	.ds.l	1

tc_save:	.ds.l	1
crp_save:	.ds.l	2		; CRP quad word size
FEnum:		.ds.w	1
rtscode:	.ds.w	1

carry:		.ds.l	1
clockcount:	.ds.l	1
psx_uart:	.ds.b	16		; 16550UART:-1 16750UART:1 no ch:0

GetArgChar_p:	.ds.l	1
GetArgChar_c:	.ds.b	1

opt_all_flag:	.ds.b	1
opt_cut_flag:	.ds.b	1
opt_pow_flag:	.ds.b	1

int_flag:	.ds.b	1
is_id15:	.ds.b	1
		.even
sizeof_work:


* Text Section -------------------------------- *

		.cpu	68000

		.text
		.even
si_start:
		bra.s	@f
		.dc.b	'#HUPAIR',0
		.even
@@:
		lea	(work_top,pc),a6
		lea	(sizeof_work+STACK_SIZE,a6),a1

		lea	(16,a0),a0
		suba.l	a0,a1
		move.l	a1,-(sp)
		move.l	a0,-(sp)
		DOS	_SETBLOCK
		addq.l	#8,sp
		tst.l	d0
		bmi	setblock_error

		lea	(sizeof_work+STACK_SIZE,a6),sp
		clr.l	-(sp)
		DOS	_SUPER

		move.w	#RTS_CODE,(rtscode,a6)
		cmpi.b	#1,(MPUTYPE)
		bls	@f

		moveq.l	#3,d0
		IOCS	_SYS_STAT
@@:

		clr.b	(opt_all_flag,a6)
		clr.b	(opt_cut_flag,a6)
		clr.b	(opt_pow_flag,a6)

		pea	(1,a2)
		bsr	GetArgCharInit
		addq.l	#4,sp
arg_loop:
		bsr	GetArgChar
		tst.l	d0
		beq	arg_loop
		bmi	arg_end
		cmpi.b	#'-',d0
		bne	print_short_help

		bsr	GetArgChar
option_loop:
		cmpi.b	#'-',d0
		beq	long_option		;--***
		cmpi.b	#'?',d0
		beq	print_long_help		;-?

		ori.b	#$20,d0
		cmpi.b	#'f',d0
		beq	option_f		;-f-***

		cmpi.b	#'a',d0
		beq	option_a
		cmpi.b	#'c',d0
		beq	option_c
		cmpi.b	#'h',d0
		beq	print_long_help
		cmpi.b	#'i',d0
		beq	print_interrupt
		cmpi.b	#'p',d0
		beq	option_p
		cmpi.b	#'s',d0
		beq	print_scsi_info
		cmpi.b	#'v',d0
		beq	print_version

		bra	print_short_help

option_all:	moveq	#0,d0
option_a:	not.b	(opt_all_flag,a6)
		bra	@f

option_cut:	moveq	#0,d0
option_c:	not.b	(opt_cut_flag,a6)
		bra	@f

option_power:	moveq	#0,d0
option_p:	not.b	(opt_pow_flag,a6)
@@:		tst	d0
		beq	arg_loop		;--all,--cut,--power

		bsr	GetArgChar		;-a,-c,-pȂ瑱Ďwł
		tst.b	d0
		bne	option_loop
		bra	arg_loop

option_f:
		bsr	GetArgChar
		cmpi.b	#'-',d0
		bne	print_short_help

		lea	(option_f_table1,pc),a1
		lea	(option_f_table2,pc),a2
		bra	@f
long_option:
		lea	(long_opt_table1,pc),a1
		lea	(long_opt_table2,pc),a2
@@:
		subq.l	#LONG_OPT_MAX,sp
		lea	(sp),a0
		moveq	#LONG_OPT_MAX-1,d1
get_long_option_loop:
		bsr	GetArgChar
		move.b	d0,(a0)
		beq	@f
		ori.b	#$20,(a0)+
		dbra	d1,get_long_option_loop
		addq.l	#LONG_OPT_MAX,sp	;IvV
		bra	print_short_help
@@:
search_long_option_loop:
		lea	(sp),a0			;"-f-","--"̎r
@@:
		move.b	(a1)+,d0
		beq	search_long_option_nul
		cmp.b	(a0)+,d0
		beq	@b

@@:		tst.b	(a1)+			;c΂
		bne	@b
search_long_option_next:
		addq.l	#2,a2
		tst.b	(a1)
		beq	print_short_help	;Ȃ
		bra	search_long_option_loop
search_long_option_nul:
		tst.b	(a0)+
		bne	search_long_option_next

		addq.l	#LONG_OPT_MAX,sp	;IvV
		adda	(a2),a2
		jmp	(a2)

arg_end:
*		tst.b	(opt_all_flag,a6)
*		bne	@f
		tst.b	(opt_pow_flag,a6)	;--all,--cutD
		bne	benchmark_only
*@@:
	.ifdef	__PRINT_SI_VER__
		bsr	print_si_version
	.endif
		bsr	print_host
		bsr	print_clockswitch
		bsr	print_mpu
		bsr	print_mpu_revision
		bsr	print_cache
		bsr	print_mmu
		bsr	print_fpu
		bsr	print_romver
		bsr	print_vernum
		bsr	print_syspatch
		bsr	print_float
		bsr	print_twoscsi
		bsr	print_memory_size
		bsr	print_himem_size
		bsr	print_sram
		bsr	print_power_off_count
		bsr	print_bootinf
		bsr	print_ontime
		bsr	print_runtime
		bsr	print_error_count
		bsr	print_scsi
		bsr	print_psx16750
		bsr	print_board1
		bsr	print_board2
		bsr	print_board3
		bsr	print_board4
		bsr	print_printer

		tst.b	(opt_cut_flag,a6)
		bne	skip_benchmark
benchmark_only:
		bsr	print_processor_pfm
		bsr	print_system_pfm
		bsr	print_machine_pfm
skip_benchmark:
		DOS	_EXIT


*
*				Sig̃o[W				   
*
* 񍐂Őo[Wʒm悤:-)

	.ifdef	__PRINT_SI_VER__
print_si_version:
		pea	(si_ver_mes,pc)
		DOS	_PRINT
		addq.l	#4,sp
		rts


si_ver_mes:	.dc.b	'System Information	:	version '
		.dc.b		version,' (',date,')',CRLF,0
		.even
	.endif


*
*                               {̋@햼                                       
*

* dl:
*	68030/68000[hŊeANZ[^{[hFȂ.
*	X68030ƓCompact𔻕ʂłȂ.
*	̋@𔻕ʂłȂ.
*	68060ڂ040turbo040turboƕ\(̕s).

print_host:
		lea	(-512,sp),sp
		lea	(sp),a0
		lea	(host_title,pc),a1
		STRCPY	a1,a0

		bsr	is_xellent30
		tst.l	d0
		bmi	@f

		lea	(host_xellent30,pc),a1	;Xellent30 on X68000...
		add.b	d0,(13,a1)		;Xellent30(ID:x) on ...
		STRCPY	a1,a0
		bra	print_host_x680x0
@@:
		cmpi.b	#3,(MPUTYPE)
		bls	print_host_x680x0	;ANZ[^

* 040syspatch.sys060turbo.sysgݍ܂́AMPU68040/68060
* 邱ƂłAȊO̗v040turbo/060turbȏ݂mF邱Ƃ
* s\(Ǝv). āA68030[hŋNꍇ͔ʂłȂ.

		lea	(host_060turbo,pc),a1
		bsr	is_060turbo
		beq	@f			;060turbo on X68030
		addq.l	#1,d0
		beq	print_host_x680x0
*		lea	(host_040turbo,pc),a1
		subq.b	#'6'-'4',(1,a1)		;040turbo on X68030

		move	#$c002,d1		;jupiter.x & 060turbo.sysŗL
		IOCS	_SYS_STAT
		addq.l	#1,d0
		beq	@f
		lea	(host_jupiter,pc),a1	;JUPITER-X on X68000
@@:
		STRCPY	a1,a0
		bra	print_host_x680x0

print_host_x680x0:
		cmpi.b	#$dc,(SYS_P6)
		beq	print_host_x68030
*print_host_x68000:
		lea	(host_x68000,pc),a1
		IOCS	_ROMVER
		move.l	d0,d1
		rol.l	#8,d1
		cmpi.l	#ROMVER_V1_00,d0
		beq	print_host_set		;X68000(㏉ROM)

		STRCPY	a1,a0
		move.b	#' ',(a0)+
		lea	(host_xvi,pc),a1

		cmpi.b	#$11,d1
		beq	print_host_set		;X68000 XVI

		lea	(host_xvi_c,pc),a1
		cmpi.b	#$12,d1
		beq	print_host_set		;X68000 XVI Compact

		lea	(host_unknown,pc),a1
		cmpi.l	#ROMVER_V1_00P,d0
		bne	print_host_set		;s...

		bsr	is_exist_builtin_scsi
		lea	(host_super,pc),a1
		tst.l	d0
		bne	print_host_set		;X68000 SUPER
	.if	0
		lea	(host_expert,pc),a1
		cmpi.b	#$20,($ff079b)
		beq	print_host_set		;X68000 EXPERT
	.endif
		lea	(host_68series,pc),a1
		bra	print_host_set		;ʕs\

print_host_x68030:
		lea	(host_x68030,pc),a1
		bra	print_host_set		;X68030(Compact)

print_host_set:
		STRCPY	a1,a0

		move.b	#' ',(a0)+
		move.b	#'(',(a0)+

		pea	(a0)
		clr.l	-(sp)
		pea	(env_hostname,pc)
		DOS	_GETENV
		addq.l	#12-4,sp
		move.l	d0,(sp)+
		bmi	print_host_no_env
@@:
		tst.b	(a0)+
		bne	@b
		move.b	#')',(-1,a0)
		bra	@f
print_host_no_env:
		subq.l	#2,a0			;" ("͂ςsv
@@:
		STRCPY_CRLF a0
		bsr	print_stack_buffer
		lea	(512,sp),sp
		rts


* Xellent30ڂĂ邩𒲂ׂ.
* out	d0.l	-1 = Ȃ  != -1  AlXellent30ID.

; BASE_ADDR.b BASE_ADDR+$80.b BASE_ADDR+$100.b SăANZXł Xellent30
; Xellent30DIP-SWɂI/O}bsOGAύX\.
; ID:3defaultȂ̂ 猟Ă.
; ID3 -> ID2 -> ID1 -> ID0̏.

is_xellent30:
		movem.l	d7/a0/a1,-(sp)
		lea.l	($ecc000),a1		; Xellent30 ID:3 BASE ADRESS
		moveq.l	#4-1,d7
1:
		movea.l	a1,a0			; BASE ADRESS
		bsr	check_bus_error_byte
		bne	is_xellent30_false

		lea.l	($80,a0),a0		; BASE ADRESS+$80
		bsr	check_bus_error_byte
		bne	is_xellent30_false

		lea.l	($80,a0),a0		; BASE ADRESS+$100
		bsr	check_bus_error_byte
		bne	is_xellent30_false
*is_xellent30_true:
		moveq.l	#0,d0
		move.w	d7,d0
		bra	@f
is_xellent30_false:
		lea.l	-$4000(a1),a1
		dbra	d7,1b
		moveq.l	#-1,d0			; Xellent30݂͑Ȃ

@@:		movem.l	(sp)+,d7/a0/a1
		rts


host_title:	.dc.b	'host computer		:	',0
*host_040turbo:	.dc.b	'040turbo on ',0
host_060turbo:	.dc.b	'060turbo on ',0
host_jupiter:	.dc.b	'Jupiter-X on ',0
host_x68030:	.dc.b	'X68030',0
*host_x68030_c:	.dc.b	'X68030 Compact',0
host_xellent30:	.dc.b	'Xellent30(ID:0) on ',0
host_x68000:	.dc.b	'X68000',0
host_xvi:	.dc.b	'XVI',0
host_xvi_c:	.dc.b	'XVI Compact',0
host_super:	.dc.b	'SUPER',0
*host_expert:	.dc.b	'EXPERT',0
host_68series:	.dc.b	'series',0
host_unknown:	.dc.b	'???',0
env_hostname:	.dc.b	'HOSTNAME',0
		.even


*
*                  XVI(Compact XVI) Clock Switch̃`FbN                     
*

print_clockswitch:
		tst.b	(opt_all_flag,a6)
		bne	@f
		IOCS	_ROMVER
		rol.l	#8,d0
		cmpi.b	#$11,d0			;X68000XVI(ROM ver. 1.1)
		beq	@f
		cmpi.b	#$12,d0			;X68000XVI Compact(ROM ver. 1.2)
		bne	print_clockswitch_end
@@:
		lea	(-256,sp),sp
		lea	(sp),a0
		lea	(clocksw_title,pc),a1
		STRCPY	a1,a0

		moveq	#%1111_0000,d0
		or.b	(SYS_P6),d0
		not	d0			;%0000=10MHz ... %0110=50MHz
		lea	(clocksw_mes,pc),a1
		cmpi	#%0110,d0
		bcc	@f			;ꉞG[
		add	d0,d0
		move	(clocksw_table,pc,d0.w),(a1)
@@:
		STRCPY	a1,a0

		bsr	print_stack_buffer
		lea	(256,sp),sp
print_clockswitch_end:
		rts


clocksw_table:	.dc	'10','16','20','25','33','40','50'
clocksw_mes:	.dc	'??'
		.dc.b	'MHz mode',CRLF,0
clocksw_title:	.dc.b	'clock switch		:	',0
		.even


*
*                               Micro Processor Unit                             
*

print_mpu:
		lea	(-512,sp),sp
		lea	(sp),a0
		lea	(mpu_title,pc),a1
		STRCPY	a1,a0

		pea	(a0)
		clr.l	-(sp)
		pea	(env_mpupack,pc)
		DOS	_GETENV
		addq.l	#12-4,sp
		move.l	d0,(sp)+
		bmi	print_mpu_no_env
@@:
		tst.b	(a0)+
		bne	@b
		subq.l	#1,a0
		bra	print_mpu_clock
print_mpu_no_env:
		bsr	mputype_check
		move.b	d0,d2
		cmpi.b	#3,d2
		bne	@f

		bsr	check_mmu
		lea	(mpu_68ec030,pc),a1
		tst.b	d0
		bne	print_mpu_without_mmu
@@:
		lea	(mpu_68000,pc),a1
		add.b	d2,(3,a1)
print_mpu_without_mmu:
		STRCPY	a1,a0
print_mpu_clock:
		move.b	#' ',(a0)+
		move.b	#'(',(a0)+

		bsr	mputype_check
		lea.l	dbra_clock(pc),a1
		add.w	d0,d0
		move.w	(a1,d0.w),d1
		bsr	count_sram_1ms_loop
		mulu	d1,d0
		moveq	#50,d1
		add.l	d1,d0
		move.l	#100000,d1
		FPACK2	__UDIV			;clock(MHz)*10
		move.l	d0,(clockcount,a6)
print_mpu_clock_print:
		lea	(mpu_mhz,pc),a1
		divu	#10,d0
		swap	d0
		add.b	d0,(1,a1)		;
		clr	d0
		swap	d0			;
		FPACK2	__LTOS
		STRCPY	a1,a0			;.?MHz)

		bsr	print_stack_buffer
		lea	(512,sp),sp
		rts


* NbNv -------------------------------- *
* S-RAM1msdbra̋󃋁[vsł邩𑪒肷.
* *12*1000MHz܂(12dbra+wait̓NbN).
* ȂAROMj^[NɈꎞIɌv[`ł.
* AMC68000@Ŏs̏ꍇSRAMgp.
* 荞݂Timer-Bgp.
* out	d0.w	[v

COUNT_ADR:	.equ	$ed00c0
COUNT_ADR2:	.equ	$1000
COUNT_SIZE:	.equ	count_sram_1ms_job_end-count_sram_1ms_job

count_sram_1ms_loop:
		PUSH	d1-d7/a0-a6
		move	sr,-(sp)
		ori	#$0700,sr

		lea	(COUNT_ADR),a6
		bsr	mputype_check
		tst.b	d0
		beq	@f
		lea	(COUNT_ADR2),a6
@@:
		lea	(-COUNT_SIZE,sp),sp
		SRAM_WRITE_ENABLE
		lea	(count_sram_1ms_job,pc),a0
		lea	(a6),a1
		lea	(sp),a2
		moveq	#COUNT_SIZE/2-1,d0
@@:
		move	(a1),(a2)+		;̃f[^ۑ
		move	(a0)+,(a1)+		;v[`
		dbra	d0,@b

		lea	(MFP),a0
		moveq	#$00,d0			;Timer-B̂݋
		moveq	#$01,d1			;

		bclr.b	#3,(SYS_P4)		;L[f[^M֎~

		move.b	(~MFP_IMRA,a0),-(sp)
		move.b	d0,(~MFP_IMRA,a0)
		move.b	(~MFP_IMRB,a0),-(sp)
		move.b	d0,(~MFP_IMRB,a0)

		move.b	(~MFP_IERA,a0),-(sp)
		move.b	d0,(~MFP_IERA,a0)
		move.b	(~MFP_IERB,a0),-(sp)
		move.b	d0,(~MFP_IERB,a0)

		move.b	#0,(~MFP_TBCR,a0)	;Timer-B~

		move.l	(TIMERB_VEC*4),-(sp)
		pea	(count_sram_1ms_int,pc)
		move.l	(sp)+,(TIMERB_VEC*4)

		move.b	d1,(~MFP_IMRA,a0)
		move.b	d1,(~MFP_IERA,a0)

		cmpi.b	#1,(MPUTYPE)
		bls	@f

		clr.b	d4
		cmpi.b	#3,(MPUTYPE)
		bls	1f

		bsr	is_060turbo
		seq.b	d4			;060turbo : $FF
		bne	4f

		moveq.l	#3,d1
		IOCS	_SYS_STAT		;cache clear

		move.w	#$C007,d1
		moveq.l	#$1f,d2			; dc/ic/ss/sb/bc enable
		IOCS	_SYS_STAT
		move.l	d0,d2
		bra	9f
4:
		moveq.l	#3,d1
		IOCS	_SYS_STAT		;cache clear

		moveq.l	#4,d1
		moveq.l	#3,d2			;cache on id
		IOCS	_SYS_STAT
		move.l	d0,d2
		bra	9f
1:
		moveq.l	#4,d1
		moveq.l	#3,d2			;cache on id
		IOCS	_SYS_STAT
		move.l	d0,d2

9:
		movem.l	d0-d2,-(a7)
		move.w	#$8004,d1
		moveq.l	#0,d2
		movea.l	a6,a1			; (a6)1pagê݃LbV
		IOCS	_SYS_STAT
		move.l	d0,d6
		movem.l	(a7)+,d0-d2
@@:
		jsr	(a6)			;ROMܰ/SRAMŌv
		ori	#$0700,sr

		move.b	#$00,(~MFP_TBCR,a0)

		cmpi.b	#1,(MPUTYPE)
		bls	@f

		cmpi.b	#3,(MPUTYPE)
		bls	1f

		movem.l	d0-d1,-(a7)
		moveq.l	#3,d1
		IOCS	_SYS_STAT		;cache clear
		movem.l	(a7)+,d0-d1
		bra	2f
1:
		movem.l	d0-d1,-(a7)
		moveq.l	#3,d1
		IOCS	_SYS_STAT		;cache clear
		movem.l	(a7)+,d0-d1
2:
		movem.l	d0-d2,-(a7)
		movea.l	a6,a1
		move.w	#$8004,d1
		move.l	d6,d2			;LbVԂɖ߂
		IOCS	_SYS_STAT
		movem.l	(a7)+,d0-d2
		movem.l	d0-d1,-(a7)
		tst.b	d4
		bne	3f

		moveq.l	#4,d1			;cache restore
		IOCS	_SYS_STAT
		movem.l	(a7)+,d0-d1
		bra	@f
3:
		move.w	#$C007,d1		;cache restore
		IOCS	_SYS_STAT
		movem.l	(a7)+,d0-d1
@@:
		move.l	(sp)+,(TIMERB_VEC*4)

		move.b	#$0d,(~MFP_TBDR,a0)
		move.b	#$01,(~MFP_TBCR,a0)
		move.b	(sp)+,(~MFP_IERB,a0)
		move.b	(sp)+,(~MFP_IERA,a0)
		move.b	(sp)+,(~MFP_IMRB,a0)
		move.b	(sp)+,(~MFP_IMRA,a0)

		bset.b	#3,(SYS_P4)		;L[f[^M

		neg	d1
		subq	#1,d1

		lea	(a6),a1
		lea	(sp),a2
		moveq	#COUNT_SIZE/2-1,d0
@@:
		move	(a2)+,(a1)+		;̃f[^ɖ߂
		dbra	d0,@b
		SRAM_WRITE_DISABLE
		lea	(COUNT_SIZE,sp),sp

		moveq	#0,d0
		move	d1,d0
		bne	@f
		move	#979,d0
@@:		move	(sp)+,sr
		POP	d1-d7/a0-a6
		rts

* in	a0.l	MFP
*	a5.l	߂AhX
* out	d1.w	dbra̎c

count_sram_1ms_job:
		move.b	#250,(~MFP_TBDR,a0)		;
		moveq	#-1,d1
		move	#$2500,sr
		move.b	#$03,(~MFP_TBCR,a0)
count_sram_1ms_job_loop:
		dbra	d1,count_sram_1ms_job_loop
count_sram_1ms_job_rts:
		rts					;܂S-RAMɓ]
count_sram_1ms_job_end:

count_sram_1ms_int:
		pea	(count_sram_1ms_job_rts,pc)	;dbrã[v甲
		move.l	(sp)+,(2,sp)
		rte


;
;	eMPU𔻒肷.
;
;  out  : d0.l   eMPU10̈ʂ.
;                (68060 Ȃ 6)
;

mputype_check:
		move.w	SR,-(a7)		; SRۑ
		ori.w	#$0700,SR
		movem.l	d1-d7/a0-a6,-(a7)

		move.l	a7,d7
		move.l	(ILLEGAL_VEC*4),a5

		lea.l	mputype_illegal(pc),a0	; s߃xN^tbN
		move.l	a0,(ILLEGAL_VEC*4)

		moveq.l	#0,d0

		.cpu	68010
		move.w	ccr,d0			;68000ł͕s

		.cpu	68020
@@:		moveq.l	#1,d0
		and.b	(@b-1,pc,d0.w*2),d0	;68010łͽ̧޺ނȂ

		bne	@f			;eq = 68010
		moveq.l	#1,d0			;68010
		bra	mputype_illegal
@@:
		.cpu	68030
		movec.l	cacr,d6			;cacrǂݏo
		move.l	d6,d5			;d6.l = original cacr
		bset.l	#31,d5			;040̃f[^LbVenableĂ݂
		bset.l	#8,d5			;020̃f[^LbVenableĂ݂

		movec.l	d5,cacr
		movec.l	cacr,d4			;cacrǂݏo
		movec.l	d6,cacr			;cacrA

		btst.l	#31,d4			;040/060ްenable??
		bne	@f			;enableȂ020/030Ȃ
		btst.l	#8,d4			;ްenableɂȂ??
		bne	@f			;enableȂ030
		moveq.l	#2,d0			;68020
		bra	mputype_illegal
@@:
		.cpu	68040
		moveq.l	#3,d0
		movec.l	tc,d5			;68030Ȃs

		.cpu	68060
		moveq.l	#4,d0			;ł040060Ȃ
		movec.l	pcr,d5			;68040ł͕s

		moveq.l	#6,d0
		.cpu	68000
mputype_illegal:
		move.l	d7,a7			;spA
		move.l	a5,(ILLEGAL_VEC*4)	;s߃xN^A
		move.b	d0,(MPUTYPE)		;VXe[N𐳂Zbg
		movem.l	(a7)+,d1-d7/a0-a6
		move.w	(a7)+,SR		;݋
		rts

mpu_title:	.dc.b	'micro processing unit	:	',0
mpu_68000:	.dc.b	'68000',0
mpu_68ec030:	.dc.b	'68EC030',0
mpu_mhz:	.dc.b	'.0MHz)',CRLF,0
env_mpupack:	.dc.b	'MPUPACK',0
dbra_clock:					; NbNvZ̊le[u
						; Œ菬_ǂ(
		.dc.w	11*1000+991		; MC68000
		.dc.w	11*1000+991		; MC68010
		.dc.w	6*1000			; MC68020
		.dc.w	6*1000			; MC68030
		.dc.w	4*1000			; MC68040
		.dc.w	0
		.dc.w	2*1000			; MC68060

		.even

*
*                             MPU revision number                                
*

print_mpu_revision:
		lea.l	(-256,a7),a7
		lea.l	(a7),a0

		bsr	mputype_check
		cmpi.b	#6,d0
		bne	mpu_revision_skip

		lea.l	(mpurev_title,pc),a1
		STRCPY	a1,a0

		.cpu	68060
		movec.l	pcr,d7
		.cpu	68000

		swap.w	d7			; identification𓾂
		moveq.l	#0,d0
		move.w	d7,d0

		move.b	#'$',(a0)+

		moveq.l	#4-1,d6
@@:
		rol.w	#4,d0
		move.b	d0,d1
		andi.b	#15,d1
		cmpi.b	#9,d1
		bcs	1f
		addi.b	#'@'-'0'-9,d1
1:		addi.b	#'0',d1
		move.b	d1,(a0)+
		dbra	d6,@b

		bsr	strcpy_slash

		move.b	#'$',(a0)+

		rol.l	#8,d7			; revision no.𓾂
		move.b	d7,d0
		moveq.l	#2-1,d6
@@:
		rol.b	#4,d0
		move.b	d0,d1
		andi.b	#15,d1
		cmpi.b	#9,d1
		bcs	1f
		addi.b	#'@'-'0'-9,d1
1:		addi.b	#'0',d1
		move.b	d1,(a0)+
		dbra	d6,@b
		STRCPY_CRLF a0
		bsr	print_stack_buffer
mpu_revision_skip:
		lea.l	(256,a7),a7
		rts

mpurev_title:	.dc.b	'ID / revision number	:	',0
		.even


*
*                             On-Chip Cachȅ                                
*

print_cache:
		lea	(-256,sp),sp
		lea	(sp),a0

		move.b	(MPUTYPE),d2
		cmpi.b	#6,d2
		bne	@f
		bsr	is_060turbo
		beq	print_cache_68060
@@:
		lea	(cache_title,pc),a1
		STRCPY	a1,a0

		subq.b	#2,d2
		bcs	print_cache_nothing	;68010loop mode邯ǂ...
		moveq	#1,d1
		IOCS	_SYS_STAT
		tst.b	d2
		beq	print_cache_68020

;68030/68040(instruct / data)
		moveq	#0,d1			;
		bsr	print_cache_on_off
		bsr	strcpy_slash
		moveq	#1,d1			;f[^
		bsr	print_cache_on_off
		bra	print_cache_over2

print_cache_68060:
		lea	(cache_title060,pc),a1
		STRCPY	a1,a0

;(Superscalar / Branch Cache / Store Buffer / Instruction / Data)
		move	#$c006,d1
		IOCS	_SYS_STAT
		moveq	#4,d1
		bra	@f
print_cache_68060_loop:
		bsr	strcpy_slash
@@:		bsr	print_cache_on_off
		dbra	d1,print_cache_68060_loop
		bra	print_cache_over2

print_cache_68020:
		moveq	#0,d1			;
		bsr	print_cache_on_off
		bsr	strcpy_slash
		lea	(no_data_cache,pc),a1
		bra	print_cache_over

print_cache_nothing:
		tst.b	(opt_all_flag,a6)
		beq	print_cache_skip

		lea	(without_cache,pc),a1
print_cache_over:
		STRCPY	a1,a0
print_cache_over2:
		STRCPY_CRLF a0
		bsr	print_stack_buffer
print_cache_skip:
		lea	(256,sp),sp
		rts

strcpy_slash:
	.irpc	char," / "
		move.b	#'&char',(a0)+
	.endm
		rts

print_cache_on_off:
		move.l	a1,-(a7)
		lea.l	enable_str(pc),a1
		btst	d1,d0
		bne	@f
		lea.l	disable_str(pc),a1
@@:
		STRCPY	a1,a0
		movea.l	(a7)+,a1
		rts

* 040/060turbogݍ܂Ă邩ׂ.
* mpu68020ȏł邱ƂmFĂĂяo.
* out	d0.l	040/060turbo.sys̃o[W(-1Ȃ68030ȉ.)
*	ccr	Z=0:040turbo Z=1:060turbo


is_060turbo:
		PUSH	d1/a1
		bsr	mputype_check
		cmpi.b	#3,d0
		beq	1f
		move	#$8000,d1
		IOCS	_SYS_STAT
		cmpa.l	#'060T',a1
2:
		POP	d1/a1
		rts
1:
		moveq.l	#-1,d0
		bra	2b

cache_title:	.dc.b	'cache (instruct / data)	:	',0
cache_title060:	.dc.b	'cache (ss/bc/sb/i/d)	:	',0
without_cache:	.dc.b	'no cache',0
no_data_cache:	.dc.b	'no data cache',0
enable_str:	.dc.b	'enable',0
disable_str:	.dc.b	'disable',0
		.even


*
*                     Memory Management Unit̃`FbN                           
*

print_mmu:
		lea	(-256,sp),sp
		lea	(sp),a0
		lea	(mmu_title,pc),a1
		STRCPY	a1,a0

		move.b	(MPUTYPE),d2
		beq	print_mmu_nothing

		bsr	check_mmu
		tst.b	d0
		bne	print_mmu_nothing

		subq.b	#3,d2
		bcc	@f
		lea	(mmu_68851,pc),a1
		bra	@f
print_mmu_nothing:
		tst.b	(opt_all_flag,a6)
		beq	print_mmu_skip

		lea	(not_install,pc),a1
@@:
		STRCPY	a1,a0
		bsr	print_stack_buffer
print_mmu_skip:
		lea	(256,sp),sp
		rts

check_mmu:					; MMU
		bsr	mputype_check
		cmp.b	#3,d0
		bls	mmuchk_030

		lea.l	(mmu_internal,pc),a1	; 040ȍ~͓MMU
		moveq.l	#0,d0
		rts

mmuchk_030:					; 68030/68020͂.
						; ł̓}bsOɂ`FbN

		.cpu	68030

		movem.l	a0/a5,-(a7)
		move.w	SR,-(a7)
		ori.w	#$0700,SR		; ݋֎~
		pmove.l	tc,(tc_save,a6)		; tcޔ
		move.l	(tc_save,a6),-(a7)
		andi.l	#$7fff_ffff,(a7)	; MMU~
		pmove.l	(a7),tc
		addq.w	#4,a7

		pmove.q	crp,(crp_save,a6)	; crpޔ
		lea.l	-128(a7),a7		; [Nm
		movea.l	a7,a0

		move.l	#$7fff_0002,(a0)+	; limit checkȂ,short descripter

		move.l	a7,d0
		lsr.l	#4,d0
		addq.l	#2,d0
		lsl.l	#4,d0
		move.l	d0,(a0)			; e[uAhXZo

		lea.l	page_desc(pc),a0
		movea.l	d0,a1
		moveq.l	#16-1,d0		; y[WfBXNv^X^bNɍ쐬
@@:
		move.l	(a0)+,(a1)+
		dbra	d0,@b

		pflusha				; ATC
		pmove.q	(a7),crp		; crpɃfBXNv^Zbg

		lea.l	mmu_enable(pc),a5
		pmove.l	(a5),tc			; MMUJn

		lea.l	$F00000,a0		; ROM adress
		lea.l	$E00000,a1		; TEXT VRAM adress
		move.w	#$1000/4-1,d0		; 4kbyterĂ݂
@@:
		cmpm.l	(a0)+,(a1)+
		dbne	d0,@b			; ႢMMU͂Ȃ
		sne.b	d0

		move.l	(tc_save,a6),-(a7)
		andi.l	#$7fff_ffff,(a7)	; MMU~
		pmove.l	(a7),tc
		addq.w	#4,a7

		pmove.q	(crp_save,a6),crp	; CRPA

		pflusha				; ATC
		pmove.l	(tc_save,a6),tc		; tc𕜋A

		lea.l	128(a7),a7

		.cpu	68000

		move.w	(a7)+,SR		; ݋
		movem.l	(a7)+,a0/a5
		tst.b	d0
		bne	@f
		lea.l	(mmu_internal,pc),a1
		rts

@@:
		lea.l	(not_install,pc),a1
		rts

mmu_title:	.dc.b	'memory management unit	:	',0
mmu_internal:	.dc.b	'on chip MMU',CRLF,0
mmu_68851:	.dc.b	'68851',CRLF,0
not_install:	.dc.b	'not install',CRLF,0
		.even

;
;	TCւ̐ݒf[^
;
;	MMU				: enable
;	Supervisor Route Pointer	: disable
;	Function Code Look up		: disable
;	Page Size			: 8kbyte
;	Initial Shift Count		: 8bit
;
;	Table Index A			: 4bit
;	Table Index B			: 4bit
;	Table Index C			: 3bit
;	Table Index D			: not use
;
;	 (PS+IS+TIA+TIB+TIC+TID) = 32.
;	łȂꍇMMURtBM[VG[O.
;
;

mmu_enable:
	dc.l	%1000_0000__1101_1000__0100_0100__0011_0000

;	y[WfBXNv^
;	2bit DT bit.
;	ROMTEXT-VRAMւƃ}bsOĂ݂...

page_desc:
	dc.l	$0000_0000.or.1
	dc.l	$0010_0000.or.1
	dc.l	$0020_0000.or.1
	dc.l	$0030_0000.or.1
	dc.l	$0040_0000.or.1
	dc.l	$0050_0000.or.1
	dc.l	$0060_0000.or.1
	dc.l	$0070_0000.or.1
	dc.l	$0080_0000.or.1
	dc.l	$0090_0000.or.1
	dc.l	$00a0_0000.or.1
	dc.l	$00b0_0000.or.1
	dc.l	$00c0_0000.or.1
	dc.l	$00d0_0000.or.1
	dc.l	$00f0_0000.or.1
	dc.l	$00f0_0000.or.1

*
*                          RvZbT[`FbN                            
*

print_fpu:
		lea	(-512,sp),sp
		lea	(sp),a0
		lea	(fpu_title,pc),a1
		STRCPY	a1,a0

		bsr	get_fpu_type
		add	d0,d0
		move	(@f,pc,d0.w),d0
		jmp	(@f,pc,d0.w)
@@:
		.dc	print_fpu_no_fpu-@b
		.dc	print_fpu_io_id1-@b
		.dc	print_fpu_io_id2-@b
		.dc	print_fpu_direct-@b
		.dc	print_fpu_internal-@b
		.dc	print_fpu_internale-@b
		.dc	print_fpu_internald-@b
		.dc	print_fpu_vioration-@b

print_fpu_no_fpu:
		lea	(not_install,pc),a1
print_fpu_end:
		STRCPY	a1,a0
		bsr	print_stack_buffer
		lea	(512,sp),sp
		rts

print_fpu_io_id1:
print_fpu_io_id2:
print_fpu_direct:
		bsr	print_fpu_env
		beq	print_fpu_end

		lea	(fpu_68881,pc),a1
		tst	d1
		beq	@f
		lea	(fpu_68882,pc),a1
@@:		STRCPY	a1,a0

		bsr	is_xellent30
		spl.b	d0
		cmpi.b	#3,(MPUTYPE)
		seq.b	d1
		and.b	d0,d1
		bne	1f			;Xellentڂ030ȂPLCC
		lea	(fpu_pga,pc),a1
		IOCS	_ROMVER
		cmpi.l	#ROMVER_030,d0
		bcs	@f
1:		lea	(fpu_plcc,pc),a1	;X68030ȂPLCCpbP[W
@@:		bra	print_fpu_end

print_fpu_internal:
		bsr	print_fpu_env
		beq	print_fpu_end

		lea	(fpu_internal,pc),a1
		bra	print_fpu_end

print_fpu_internale:
		bsr	print_fpu_env
		beq	print_fpu_end

		lea	(fpu_internale,pc),a1
		bra	print_fpu_end

print_fpu_internald:
		bsr	print_fpu_env
		beq	print_fpu_end

		lea	(fpu_internald,pc),a1
		bra	print_fpu_end

print_fpu_vioration:
		lea	(warning,pc),a1
		bra	print_fpu_end

* FPUꍇ̊ϐ\
print_fpu_env:
		pea	(a0)
		clr.l	-(sp)
		pea	(env_fpupack,pc)
		DOS	_GETENV
		addq.l	#12-4,sp
		move.l	d0,(sp)+
		bmi	print_fpu_no_env
@@:
		tst.b	(a0)+
		bne	@b
		subq.l	#1,a0
		lea	(crlf,pc),a1
		moveq	#0,d0
		rts
print_fpu_no_env:
		moveq	#-1,d0
		rts

* _ZvZbT݂邩ׂ.
* out	d0.l	0:Ȃ
*		1:I/Oڑ(ID1)
*		2:V	 (ID2)
*		3:MPU(68020-)
*		4:68040
*		5:68060(FPL)
*		6:68060(FP)
*		7:vgRoCI[Vɂ蔻s\
*	d1.l	0:68881 1:68882
* 68LC040ɃRvƂǂȂ񂾂낤...

get_fpu_type:
		move.l	a0,-(sp)
		cmpi.b	#3,(MPUTYPE)
		bls	get_fpu_type_no_internal
						;68030ȍ~͂

		bsr	mputype_check
		move.b	(1f,pc,d0.w),d0
		add.w	d0,d0
		move.w	(@f,pc,d0.w),d0
		jmp	(@f,pc,d0.w)
@@:
		.dc.w	get_fpu_type_no_internal-@b	; 030
		.dc.w	get_fpu_040internal-@b		; 040
		.dc.w	get_fpu_060internal-@b		; 060
1:
		.dc.b	0
		.dc.b	0
		.dc.b	0
		.dc.b	0
		.dc.b	1
		.dc.b	0
		.dc.b	2
		.even

get_fpu_040internal:
		moveq	#4,d0
		bra	get_fpu_type_end	;FPU
get_fpu_060internal:
		.cpu	68060
		movec.l	pcr,d0
		btst.l	#1,d0			; DFPbit
		bne	@f
		moveq.l	#5,d0			; FPL
		bra	get_fpu_type_end
@@:
		moveq.l	#6,d0			; FP
		bra	get_fpu_type_end
		.cpu	68000
get_fpu_type_no_internal:
		cmpi.b	#1,(MPUTYPE)
		bls	get_fpu_type_no_direct

		bsr	check_directfpu
		add.w	d0,d0
		move.w	(@f,pc,d0.w),d0
		jmp	(@f,pc,d0.w)
@@:
		.dc.w	get_fpu_type_no_direct-@b	; RvȂ
		.dc.w	get_fpu_type_direct-@b		; Rv
		.dc.w	get_fpu_type_err-@b		; vgRoCI[VO
get_fpu_type_direct:
		moveq	#3,d0
		bra	get_fpu_type_6888x	;MPU
get_fpu_type_err:
		moveq.l	#7,d0
		bra	get_fpu_type_end
get_fpu_type_no_direct:
		lea	(IOFPU1),a0
		bsr	check_bus_error_word
		bne	@f

		moveq	#1,d0
		bra	get_fpu_type_6888x	;I/Oڑ
@@:
		lea	(IOFPU2-IOFPU1,a0),a0
		bsr	check_bus_error_word
		bne	@f

		moveq	#1,d0
		bra	get_fpu_type_6888x	;I/Oڑ
@@:
		moveq	#0,d0			;FPUȂ
get_fpu_type_end:
		movea.l	(sp)+,a0
		rts

;
; 68020/68030FPU邩ǂmF.
;
; in  : nothing
; out : d0.l
;		0 : FPU͑ĂȂ
;		1 : 68881/68882̂ꂩ
;		2 : vgRoCI[V
;

check_directfpu:
		move.w	SR,-(a7)
		ori.w	#$0700,SR		; ݋֎~
		movem.l	a0-a1,-(a7)
		move.l	(FLINE_VEC*4),a0	; fline emurator
		move.l	(PROTVIO_VEC*4),a1	; cp protocol vioration
		movem.l	a0/a1/a7,(reg_save,a6)

		lea.l	protvio(pc),a1
		move.l	a1,(PROTVIO_VEC*4)
		lea.l	fline(pc),a1
		move.l	a1,(FLINE_VEC*4)

		moveq.l	#0,d0

		.cpu	68030
		fnop				; RvɃANZX
		.cpu	68000
						; f lineOȂFPU͂Ȃ
		moveq.l	#1,d0
fline:
		movem.l	(reg_save,a6),a0/a1/a7
		move.l	a0,(FLINE_VEC*4)
		move.l	a1,(PROTVIO_VEC*4)
		movem.l	(a7)+,a0-a1
		move.w	(a7)+,SR		; ݋
		rts

protvio:					; cpĺ޲ڰݗO
		moveq.l	#2,d0
		bra	fline


* Ō68881/68882̔ʂ.
* Ql : LIBC src/math/_fpu_is68881.s
* in	d0.l	FPUڑ@(1`4)
*	a0.l	FPUI/OAhX(d0=1,2̂)
* out	d0.hw	0:68881 0ȊO:68882

get_fpu_type_6888x:
		cmpi	#2,d0
		bls	get_fpu_type_6888x_io

;Ȃfpu߂g.
;(ł͎g܂)
		.cpu	68030
		fmovecr.x #$01,fp0
		fmove.d	fp0,-(sp)
		.cpu	68000
		bra	get_fpu_type_6888x_end

;I/OڑȂ烁o.
get_fpu_type_6888x_io:
		move	#$5c01,($a,a0)
@@:		tst	(a0)
		bmi	@b
		move	#$7400,($a,a0)
@@:		btst	#4,(a0)
		beq	@b
		subq.l	#8,sp
		move.l	($10,a0),(0,sp)
		move.l	($10,a0),(4,sp)
@@:		tst	(a0)
		bmi	@b
get_fpu_type_6888x_end:
		move.l	(sp)+,d1
		or.l	(sp)+,d1
		beq	@f
		moveq	#1,d1			;fpu rom[1]̒l0(=0.0)ȊOȂ68882
@@:		bra	get_fpu_type_end


fpu_title:	.dc.b	'floating point unit	:	',0
fpu_internal:	.dc.b	'on chip FPU',CRLF,0
fpu_internale:	.dc.b	'on chip FPU(enable)',CRLF,0
fpu_internald:	.dc.b	'on chip FPU(disable)',CRLF,0
fpu_68881:	.dc.b	'68881',0
fpu_68882:	.dc.b	'68882',0
fpu_pga:	.dc.b	'(PGA)',CRLF,0
fpu_plcc:	.dc.b	'(PLCC)',CRLF,0
env_fpupack:	.dc.b	'FPUPACK',0
warning:
	.dc.b	CRLF,CRLF
	.dc.b	'x:',CRLF
	.dc.b	'FPU vgRoCI[VO܂.',CRLF
	.dc.b	'FPȔႵĂȂAɑĂ邩mFĂ.'
	.dc.b	CRLF,CRLF,0
		.even


*
*                                   Rom version                                  
*

print_romver:
		lea	(-256,sp),sp
		lea	(sp),a0
		lea	(romver_title,pc),a1
		STRCPY	a1,a0

		IOCS	_ROMVER
		bsr	print_romver_sub
		move.b	#'.',(a0)+
		bsr	print_romver_sub
		move.b	#'0',(a0)+
		move.b	#' ',(a0)+

		move.b	#"'",(a0)+
		bsr	print_romver_sub	;
		bsr	print_romver_sub
		moveq	#'/',d2
		move.b	d2,(a0)+
		bsr	print_romver_sub	;
		bsr	print_romver_sub
		move.b	d2,(a0)+
		bsr	print_romver_sub	;
		bsr	print_romver_sub

		STRCPY_CRLF a0
		bsr	print_stack_buffer
		lea	(256,sp),sp
		rts

print_romver_sub:
		rol.l	#4,d0
		moveq	#$f,d1
		and.b	d0,d1
		addi.b	#'0',d1
		move.b	d1,(a0)+
		rts


romver_title:	.dc.b	'BIOS ROM		:	version ',0
		.even


*
*                                 nr̃o[W                               
*

print_vernum:
		lea	(-256,sp),sp
		lea	(sp),a0
		lea	(vernum_title,pc),a1
		STRCPY	a1,a0

		DOS	_VERNUM
		move.b	d0,-(sp)
		move	d0,-(sp)
		moveq	#0,d0
		move.b	(sp)+,d0		;o[W
		FPACK2	__LTOS
		move.b	#'.',(a0)+

		moveq	#0,d0
		move.b	(sp)+,d0		;o[W
		cmpi.b	#10,d0
		bcc	@f
		move.b	#'0',(a0)+		;$0302 -> "3.02"
@@:		FPACK2	__LTOS

		STRCPY_CRLF a0
		bsr	print_stack_buffer
		lea	(256,sp),sp
		rts


vernum_title:	.dc.b	'operating system	:	Human68k version ',0
		.even

*
*                              system patch driver                               
*
;
; dl : 040SYSpatch.x/040SRAMpatch.r𔻒łȂ.
;        VXepb`hCo #'2.06'̂悤Ȍ`Ńo[W
;        ԂĂȂꍇ̓͒m(
;

print_syspatch:
		lea	(-256,sp),sp
		lea	(sp),a5
		movem.l	a6/sp,(reg_save,a6)
		lea	(syspatch_title,pc),a2
		STRCPY	a2,a5

		pea.l	(syspatch_trap,pc)
		move.w	#TRAP14_VEC,-(sp)
		DOS	_INTVCS
		addq.w	#6,sp
		move.l	d0,(trap14_save,a6)

		bsr	is_060turbo
		beq	pr_060tsys
		moveq.l	#-1,d2
		cmp.l	d0,d2
		beq	pr_030sys

		move.l	d0,-(a7)

		move.w	#$c002,d1
		IOCS	_SYS_STAT
		tst.l	d0
		bmi	pr_040sys
;pr_jupiterx:
		lea.l	(jupiter_x,pc),a2
		bra	@f
pr_040sys:
		lea.l	(sysp_030,pc),a2
		cmpi.b	#3,(MPUTYPE)
		bls	pr_30sys
		lea.l	(sysp_040,pc),a2
@@:		move.l	(a7)+,d0
		bra	set_syspat_ver
pr_030sys:
		lea.l	(sysp_030,pc),a2
		lea.l	($ff0000),a0
		cmpi.l	#'X030',(a0)
		beq	@f
pr_30sys:	move.b	#'_',(a2)
@@:		move.w	#$8000,d1
		IOCS	_SYS_STAT
		tst.l	d0
		bpl	set_syspat_ver
no_syspatch:
		lea.l	(noinst_sysp,pc),a4
		tst.b	(opt_all_flag,a6)
		beq	print_syspatch_skip
		bra	@f
pr_060tsys:
		lea.l	(sys_060t,pc),a2
set_syspat_ver:
		STRCPY	a2,a5
		lea.l	(ver_str,pc),a4
		STRCPY	a4,a5
		exg.l	a5,a0
		bsr	print_float_sub
		exg.l	a5,a0

		lea.l	(inst_sysp,pc),a4
@@:		STRCPY	a4,a5
		STRCPY_CRLF a5
		bsr	print_stack_buffer
print_syspatch_skip:
		move.l	(trap14_save,a6),-(sp)
		move.w	#TRAP14_VEC,-(sp)
		DOS	_INTVCS
		lea	(256+6,a7),a7
		rts

syspatch_trap:
		movem.l	(work_top+reg_save,pc),a6/a7
		bra	no_syspatch


syspatch_title:	.dc.b	'system patch driver	:	',0
sys_060t:	.dc.b	'060turbo.sys',0
sysp_040:	.dc.b	'040SYSpatch.x',0
;sramp_040:	.dc.b	'040SRAMpatch.r',0
jupiter_x:	.dc.b	'Jupiter.x',0
sysp_030:	.dc.b	'030SYSpatch.x',0
ver_str:	.dc.b	' version ',0
inst_sysp:	.dc.b	' installed',0
noinst_sysp:	.dc.b	'not install',0
		.even


*
*				FLOATn.X̎					   
*

print_float:
		tst.b	(opt_all_flag,a6)
		beq	print_float_end

		lea	(-256,sp),sp
		lea	(sp),a0
		lea	(float_title,pc),a1
		STRCPY	a1,a0

		FPACK2	__FEVARG
		bsr	print_float_sub
		bsr	strcpy_slash
		move.l	d1,d0
		bsr	print_float_sub

		STRCPY_CRLF a0
		bsr	print_stack_buffer
		lea	(256,sp),sp
print_float_end:
		rts

* d0.l4oCg̕ƌȂăobt@ɓ].
* in	d0.l	(4byte)
*	a0.l	obt@
* out	a0.l	+= 4

print_float_sub:
		swap	d0
		bsr	@f
		swap	d0
@@:		move	d0,-(sp)
		move.b	(sp)+,(a0)+
		move.b	d0,(a0)+
		rts

float_title:	.dc.b	'fefunc driver		:	'
		.even

*
*				TWOSCSI system					   
*

print_twoscsi:
		tst.b	(opt_all_flag,a6)
		bne	@f

		bsr	search_twoscsi
		move.l	d0,d7
		bmi	print_twoscsi_end
@@:
		lea	(-256,sp),sp
		lea	(sp),a0
		lea	(twoscsi_title,pc),a1
		STRCPY	a1,a0

		lea.l	(notinst_mes,pc),a1
		bsr	search_twoscsi
		tst.l	d0
		bmi	@f
		lea.l	(inst_mes,pc),a1

		STRCPY	a1,a0

		lea.l	(twosc_ver,pc),a2
		move.l	a2,d1
		swap.w	d0
		move.b	d0,(a2)+
		addq.w	#1,a2
		rol.l	#8,d0
		move.b	d0,(a2)+
		rol.l	#8,d0
		move.b	d0,(a2)+
		movea.l	d1,a1
@@:
		STRCPY	a1,a0

		STRCPY_CRLF a0
		bsr	print_stack_buffer
		lea	(256,sp),sp
print_twoscsi_end:
		rts

;
; TWOSCSI driver̃foCXwb_Tăo[W𓾂
; out : d0.l  > 0  TWOSCSĨo[W(ASCII)  d0.l = 0,'053'
;             < 0  TWOSCSI͂Ȃ,܂NULfoCXȂ(?
;

		.offset	0
PREV:		.ds.l	1			;ÕǗ|C^
PARENT:		.ds.l	1			;ẽǗ|C^
END:		.ds.l	1			;ubN̏I[+1
NEXT:		.ds.l	1			;̃Ǘ|C^

		.text
		.offset	0
DEV_NEXT:	.ds.l	1
DEV_ATR:	.ds.w	1
DEV_STRATEGY:	.ds.l	1
DEV_INTR:	.ds.l	1
DEV_NAME:	.ds.b	8

		.fail	DEV_NAME.ne.14
		.text

		.fail	_GETPDB.eq.$ff51

search_twoscsi:
		movem.l	d1-d7/a0-a6,-(a7)

		DOS	_GETPDB
		movea.l	d0,a6			; PDB adress𓾂
		move.l	(-16,a6),a6		; 擪̃Ǘ|C^T
@@:
		move.l	(a6),d0
		beq	@f
		movea.l	d0,a6
		bra	@b
@@:
		movea.l	a6,a5			; a6 = Human68k̃Ǘ|C^

						; 'NUL'T
		move.l	#'NUL ',d1
		move.l	#'NU',d2
@@:
		cmp.l	#$200000,a5
		bcc	twosc_search_err
		move.l	(a5)+,d0
		cmp.l	d1,d0			; 'NUL '??
		beq	1f
		cmp.w	d2,d0			; 'NU'??
		bne	@b
		subq.w	#2,a5			; 2Ĕr蒼
		bra	@b
1:
		moveq.l	#-1,d1
		lea.l	(DEV_NEXT-DEV_NAME-4,a5),a4
@@:
		move.l	(DEV_NEXT,a4),d0
		cmp.l	d1,d0
		beq	twosc_search_err
		movea.l	d0,a4
		lea.l	(DEV_NAME,a4),a3
		cmp.l	#'2nSC',(a3)
		bne	@b
		cmp.b	#'I',(4,a3)
		bne	@b

		moveq.l	#0,d0
		addq.w	#5,a3
		move.b	(a3)+,d0		;twoscsio[W
		swap.w	d0
		move.b	(a3)+,d0		;
		rol.w	#8,d0
		move.b	(a3)+,d0		;

@@:
		movem.l	(a7)+,d1-d7/a0-a6
		rts

twosc_search_err:
		moveq.l	#-1,d0
		bra	@b


twoscsi_title:	.dc.b	'TWO-SCSI system		:	',0

inst_mes:	.dc.b	'version ',0
twosc_ver:	.dc.b	'0.00 installed',0

notinst_mes:	.dc.b	'not install',0


		.even


*
*                               C`FbN                         
*

print_memory_size:
		bsr	get_memory_free_size
		move.l	d0,d1
		bsr	get_memory_size
		lea	(memsize_title,pc),a1
		bra	print_memsize_sub
*		rts


* Ceʂ𒲂ׂ.
* out	d0.l	e(oCgP)

get_memory_size:
		move.l	a0,-(sp)
		suba.l	a0,a0
@@:
		bsr	check_bus_error_long
		bne	@f
		adda.l	#$10_0000,a0
		cmpa.l	#$c0_0000,a0
		bcs	@b
@@:
		move.l	a0,d0
		movea.l	(sp)+,a0
		rts

* C󂫗eʂ𒲂ׂ.
* out	d0.l	󂫃e(oCgP)

get_memory_free_size:
		pea	($ffffff)
		pea	(si_start-$f0,pc)
		DOS	_SETBLOCK
		addq.l	#4,sp
		and.l	d0,(sp)

		pea	($ffffff)
		DOS	_MALLOC
		and.l	(sp)+,d0

		cmp.l	(sp),d0
		bcc	@f
		move.l	(sp),d0
@@:		addq.l	#4,sp
		rts


*
*                               nC`FbN                           
*

print_himem_size:
		move.l	(_HIMEM*4+$400),a0
		cmpi	#'M'<<8,-(a0)
		bne	print_himem_size_err
		cmpi.l	#'HIME',-(a0)
		beq	print_himem_size_exist
print_himem_size_err:
		moveq	#-1,d0
		tst.b	(opt_all_flag,a6)
		bne	@f
		rts
print_himem_size_exist:
		bsr	get_himem_size
		move.l	d0,d1
		ble	print_himem_size_err
		bsr	get_himem_free_size
		exg	d0,d1
@@:
		lea	(himem_title,pc),a1
		bra	print_memsize_sub
*print_himem_size_end:
*		rts


* nCeʂ𒲂ׂ.
* 060turbo.sysIOCS _SYS_STATgĂȂ΁ATS-6BE1616MBƌȂ.
* out	d0.l	e(oCgP)
*		0ȂnCAȂG[

get_himem_size:
		PUSH	d1/a1
	.if	0
		moveq	#_HIMEM_VERSION,d1
		IOCS	_HIMEM
		cmpi.l	#'060T',d0
		bne	get_himem_size_ts6be16
	.endif
		cmpi.b	#6,(MPUTYPE)
		bcs	get_himem_size_ts6be16
		bsr	is_060turbo
		bne	get_himem_size_ts6be16

		move	#$4000,d1		;d0=size,a1=start adr.
		IOCS	_SYS_STAT
		bra	@f
get_himem_size_ts6be16:
		move.l	#16*1024*1024,d0
@@:		POP	d1/a1
		rts

* nC󂫗eʂ𒲂ׂ.
* IOCS _HIMEMgp\ȂƂmFĂĂяo.
* out	d0.l	󂫃e(oCgP)

get_himem_free_size:
		move.l	d1,-(sp)
		moveq	#_HIMEM_GETSIZE,d1
		IOCS	_HIMEM
		move.l	d1,d0
		move.l	(sp)+,d1
		rts


* eʕ\ ------------------------ *
* in	d0.l	e(0Ȃ疢)
*	d1.l	󂫗e
*		d0/d1oCg.
*	a1.l	^Cg̃AhX
* break d0-d1/a0-a1

print_memsize_sub:
		lea	(-256,sp),sp
		lea	(sp),a0
		STRCPY	a1,a0			;title
		lea	(not_install,pc),a1
		tst.l	d0
		ble	print_memsize_sub_end
;e
		move.l	d1,-(sp)
		lsr.l	#8,d0
		lsr.l	#2,d0			;1024
		moveq	#MEMSIZE_LEN,d1
		FPACK2	__IUSING
		lea	(memsize_kb,pc),a1
		STRCPY	a1,a0
;󂫗e
		move.l	(sp)+,d0
		lsr.l	#8,d0
		lsr.l	#2,d0			;1024
		moveq	#MEMSIZE_LEN,d1
		FPACK2	__IUSING
		lea	(memsize_kb_free,pc),a1
print_memsize_sub_end:
		STRCPY	a1,a0

		bsr	print_stack_buffer
		lea	(256,sp),sp
		rts


memsize_title:	.dc.b	'memory size		:	',0
himem_title:	.dc.b	'extention memory	:	',0
memsize_kb:	.dc.b	'K Bytes (',0
memsize_kb_free:.dc.b	'K Bytes Free)',CRLF,0
		.even


*
*				SRAMe/gp[h\				   
*

print_sram:
		lea	(-256,sp),sp
		lea	(sp),a0
		lea	(sram_title,pc),a1
		STRCPY	a1,a0

		bsr	get_sram_size

		lsr.l	#8,d0
		lsr.l	#2,d0			;1024
		moveq	#MEMSIZE_LEN,d1
		FPACK2	__IUSING

		lea	(sramsize_kb,pc),a1
		STRCPY	a1,a0

		lea	(sram_free,pc),a1
		move.b	(SRAM_USEMODE),d0
		beq	@f
		lea	(sram_ramdisk,pc),a1
		subq.b	#2,d0
		bcs	@f
		lea	(sram_prog,pc),a1
		beq	@f
		lea	(sram_unknown,pc),a1
@@:
		STRCPY	a1,a0

		bsr	print_stack_buffer
		lea	(256,sp),sp
		rts


* SRAMeʂ𒲂ׂ.
* out	d0.l	e(oCgP)

get_sram_size:
		move.l	a0,-(sp)
		lea	(SRAM),a0
@@:
		bsr	check_bus_error_long
		bne	@f
		lea	(1024,a0),a0
		cmpa.l	#SRAM_MAX+1,a0
		bcs	@b
@@:
		suba.l	#SRAM,a0
		move.l	a0,d0
		movea.l	(sp)+,a0
		rts


sram_title:	.dc.b	'SRAM			:	',0
sramsize_kb:	.dc.b	'K Bytes / ',0
sram_free:	.dc.b	'Free',CRLF,0
sram_ramdisk:	.dc.b	'SRAMDISK',CRLF,0
sram_prog:	.dc.b	'Program',CRLF,0
sram_unknown:	.dc.b	'???',CRLF,0
		.even


*
*				p[It񐔕\				   
*

print_power_off_count:
		lea	(-256,sp),sp
		lea	(sp),a0
		lea	(powoff_title,pc),a1
		STRCPY	a1,a0

		move.l	(SRAM_POWOFF),d0
		FPACK2	__LTOS

		STRCPY_CRLF a0
		bsr	print_stack_buffer
		lea	(256,sp),sp
		rts


powoff_title:	.dc.b	'power off count		:	',0
		.even


*
*                              NfoCX^d                            
*

print_bootinf:
		lea	(-256,sp),sp
		lea	(sp),a0
		lea	(boot_title,pc),a1
		STRCPY	a1,a0

		IOCS	_BOOTINF
		move.l	d0,-(sp)
		andi.l	#$00ff_ffff,d0
		cmpi.l	#SCSIROM,d0
		bcs	@f
		cmpi.l	#SCSIROM+4*8,d0
		bcs	print_bootinf_scsiin	;$fc00?? : SCSI-ROM
@@:		cmpi.l	#SCSIEXROM,d0
		bcs	@f
		cmpi.l	#SCSIEXROM+4*8,d0
		bcs	print_bootinf_scsiex	;$ea00?? : external SCSI-ROM
@@:		cmpi.l	#SRAM,d0
		bcs	@f
		cmpi.l	#SRAM_MAX+1,d0
		bcs	print_bootinf_sram	;$ed???? : SRAM
@@:		tst	(sp)
		bne	print_bootinf_rom
		cmpi	#$80,d0
		bcs	@f
		cmpi	#$8f,d0
		bls	print_bootinf_sasi	;$80`$8f : SASI
@@:		cmpi	#$90,d0
		bcs	@f
		cmpi	#$93,d0
		bls	print_bootinf_fdd	;$90`$93 : FDD
@@:
print_bootinf_rom:
		lea	(boot_rom,pc),a1
		bra	@f
print_bootinf_sram:
		lea	(boot_sram,pc),a1
@@:		STRCPY	a1,a0
		FPACK2	__HTOS			;NAhX
		bra	print_bootinf_switch

print_bootinf_scsiin:
		lea	(boot_scsiin,pc),a1
		bra	@f
print_bootinf_scsiex:
		lea	(boot_scsiex,pc),a1
		bra	@f
print_bootinf_sasi:
		lea	(boot_sasi,pc),a1
		bra	@f
print_bootinf_fdd:
		lea	(boot_fdd,pc),a1
@@:		STRCPY	a1,a0

print_bootinf_switch:
	.irpc	char," / "
		move.b	#'&char',(a0)+
	.endm
		move.b	(sp),d0			;ŏʃoCg=N@
		addq.l	#4,sp
		lea	(boot_power,pc),a1
		beq	@f
		subq.b	#2,d0
		lea	(boot_remote,pc),a1
		bcs	@f
		lea	(boot_timer,pc),a1
		beq	@f
		lea	(boot_unknown,pc),a1
@@:		STRCPY	a1,a0

		bsr	print_stack_buffer
		lea	(256,sp),sp
		rts


boot_title:	.dc.b	'boot device / switch	:	',0
boot_rom:	.dc.b	'ROM $',0
boot_sram:	.dc.b	'SRAM $',0
boot_scsiin:	.dc.b	'Internal SCSI',0
boot_scsiex:	.dc.b	'External SCSI',0
boot_sasi:	.dc.b	'SASI',0
boot_fdd:	.dc.b	'FDD',0
boot_power:	.dc.b	'power switch',CRLF,0
boot_remote:	.dc.b	'remote switch',CRLF,0
boot_timer:	.dc.b	'timer',CRLF,0
boot_unknown:	.dc.b	'???',CRLF,0
		.even


*
*                                NJn̎                              
*

print_ontime:
		IOCS	_ONTIME
		move.l	d1,-(sp)
		moveq	#100,d1
		FPACK2	__UDIV			;0.01b1bP
		move.l	d0,d7
		moveq	#60,d1
		FPACK2	__UMOD
		move.l	d0,d4			;b.
		move.l	d7,d0
		FPACK2	__UDIV
		move.l	d0,d6
		FPACK2	__UMOD
		move.l	d0,d3			;
		move.l	d6,d0
		FPACK2	__UDIV
		move.l	d0,d2			;Ԑ
		move.l	(sp)+,d1		;

		lea	(ontime_title,pc),a1
		bra	print_time_sub
*		rts


*
*                                ݐωғԕ\                                
*

print_runtime:
		moveq	#0,d4			;b=0
		move.l	(SRAM_ONTIME),d0

		move.l	d0,d7
		moveq.l	#60,d1
		FPACK2	__UMOD
		move.l	d0,d3			;
		move.l	d7,d0
		moveq.l	#60,d1
		FPACK2	__UDIV
		move.l	d0,d7
		moveq.l	#24,d1
		FPACK2	__UMOD
		move.l	d0,d2			;Ԑ
		move.l	d7,d0
		FPACK2	__UDIV
		move.l	d0,d1			;

		lea	(runtime_title,pc),a1
		bra	print_time_sub
*		rts


* /b𕶎ɕϊA^CgƉsLĕ\.
*  0 ̎͋󔒂Ŗ߂.
* in	d1.l	
*	d2.l	Ԑ(0`23)
*	d3.l	(0`59)
*	d4.l	b(0`59)
*	a1.l	^Cg
* break	d0-d1/a0-a1

print_time_sub:
		lea	(-256,sp),sp
		lea	(sp),a0
		STRCPY	a1,a0

		move.l	d1,d0
		bne	print_time_sub_day

		moveq	#' ',d0
		moveq	#8-1,d1			;8=strlen("65535 / ")
@@:		move.b	d0,(a0)+
		dbra	d1,@b
		bra	@f
print_time_sub_day:
		moveq	#5,d1
		FPACK2	__IUSING		;
		bsr	strcpy_slash
@@:
		move.l	d2,d0
		moveq	#2,d1
		FPACK2	__IUSING		;Ԑ

		move.l	d3,d0
		bsr	dec2_to_str		;

		move.l	d4,d0
		bsr	dec2_to_str		;b

		STRCPY_CRLF a0
		bsr	print_stack_buffer
		lea	(256,sp),sp
		rts

dec2_to_str:
		move.b	#':',(a0)+
		divu	#10,d0
		addi.l	#'0'<<16+'0',d0
		move.b	d0,(a0)+
		swap	d0
		move.b	d0,(a0)+
		rts


ontime_title:	.dc.b	'elapsed time (H:M:S)	:	',0
runtime_title:	.dc.b	'run time (day/H:M:S)	:	',0
		.even


*
*                        oXG[JEg[`                              
*

print_error_count:
		lea	(SRAM_ASKA_ID),a2
		cmpi.l	#'BEL.',(a2)+		;gݍ܂ĂȂ
		bne	print_error_count_skip	;-allł\Ȃ

		lea	(-256,sp),sp
		lea	(sp),a0
		lea	(error_title,pc),a1
		STRCPY	a1,a0

		move.l	(a2)+,d0		;SRAM_ASKA_ADR
		FPACK2	__LTOS
		bsr	strcpy_slash
		move.l	(a2)+,d0		;SRAM_ASKA_BUS
		FPACK2	__LTOS

		STRCPY_CRLF a0
		bsr	print_stack_buffer
		lea	(256,sp),sp
print_error_count_skip:
		rts


error_title:	.dc.b	'error count ADDRESS/BUS	:	',0
		.even


*
*                                  rbrh`FbN                              
*

print_scsi:
		lea	(-256,sp),sp
		lea	(sp),a0
		lea	(scsi_title,pc),a1
		STRCPY	a1,a0

		moveq	#0,d7

		bsr	is_exist_builtin_scsi
		lea	(scsi_builtin,pc),a1
		bsr	print_scsi_sub

		bsr	is_exist_scsi_board
		lea	(scsi_board,pc),a1
		bsr	print_scsi_sub

		bsr	is_exist_mach2
		lea	(scsi_mach2,pc),a1
		bsr	print_scsi_sub

		lea	(crlf,pc),a1
		tst.b	d7
		bne	@f
*		tst.b	(opt_all_flag,a6)	;ŋ߂͂̂ʂAɕ\
*		beq	print_scsi_end
		lea	(not_install,pc),a1
@@:
		STRCPY	a1,a0
		bsr	print_stack_buffer
*print_scsi_end:
		lea	(256,sp),sp
		rts


print_scsi_sub:
		tst.l	d0
		beq	print_scsi_sub_end
		tas	d7
		beq	@f
		bsr	strcpy_slash
@@:
		STRCPY	a1,a0
print_scsi_sub_end:
		rts


* SCSI݂邩ׂ.
* out	d0.l	0:Ȃ 1:

is_exist_builtin_scsi:
		PUSH	d1/a0
		lea	(SCSIIN_ID),a0
		move	#'IN',d1
		bra	@f

* SCSI{[h݂邩ׂ.
* out	d0.l	0:Ȃ 1:

is_exist_scsi_board:
		PUSH	d1/a0
		bsr	is_exist_mach2
		bne	is_exist_scsi_false

		lea	(SCSIEX_ID),a0
		move	#'EX',d1
@@:
		bsr	check_bus_error_long
		bne	is_exist_scsi_false
		cmpi.l	#'SCSI',d0
		bne	is_exist_scsi_false

		addq.l	#4,a0
		bsr	check_bus_error_word
		bne	is_exist_scsi_false
		cmp	d1,d0			;'IN'or'EX'
		bne	is_exist_scsi_false
*is_exist_scsi_true:
		moveq	#1,d0
		bra	@f
is_exist_scsi_false:
		moveq	#0,d0
@@:		POP	d1/a0
		rts

* Mach-2݂邩ׂ.
* out	d0.l	0:Ȃ 1:

is_exist_mach2:
		move.l	a0,-(sp)
		lea	(MACH2_IO),a0
		bsr	check_bus_error_long
		bne	is_exist_mach2_false
		cmpi.l	#'BIOS',d0
		bne	is_exist_mach2_false
*is_exist_mach2_true:
		movem.l	d1-d3/a2,-(a7)
		bsr	get_scsi_iocs_level
		cmp.w	#$6000,d0
		bge	@f
		swap.w	d0
@@:
		lea.l	scsi_mach2+7(pc),a1
		move.l	a1,d2
		moveq.l	#4-1,d1
		moveq.l	#'0',d3
6:		move.b	d3,(a1)+
		dbra	d1,6b

		move.l	d2,a1
		moveq.l	#4-1,d1			; SłSP^

4:		rol.w	#4,d0			; ꌅo
		move.b	d0,d2
		andi.b	#15,d2
		cmpi.b	#9,d2
		bcs	5f
		addi.b	#'@'-'0'-9,d2
5:		add.b	d2,(a1)+
		dbra	d1,4b

		movem.l	(a7)+,d1-d3/a2
		moveq	#1,d0
		bra	@f
is_exist_mach2_false:
		moveq	#0,d0
@@:
		movea.l	(sp)+,a0
		rts


scsi_title:	.dc.b	'SCSI			:	',0
scsi_builtin:	.dc.b	'built-in',0
scsi_board:	.dc.b	'expansion board',0
scsi_mach2:	.dc.b	'Mach-2(0000)',0
		.even


*
*                                  Printer `FbN                              
*

print_printer:
		lea	(-256,sp),sp
		lea	(sp),a0
		lea	(printer_title,pc),a1
		STRCPY	a1,a0

		lea	(online_mes,pc),a1
		IOCS	_SNSPRN
		tst.l	d0
		bne	@f			;o͉\
		lea	(offline_mes,pc),a1
		tst.b	(opt_all_flag,a6)
		beq	print_printer_skip
@@:
		STRCPY	a1,a0
		bsr	print_stack_buffer
print_printer_skip:
		lea	(256,sp),sp
		rts


printer_title:	.dc.b	'printer			:	',0
online_mes:	.dc.b	'online',CRLF,0
offline_mes:	.dc.b	'offline',CRLF,0
		.even


*
*                                   PSX16750                                     
*

print_psx16750:
		lea.l	(-256,a7),a7
		lea.l	(a7),a5

		lea	(psx_uart,a6),a2	;PSX16x50 UART flag
		lea	(PSX_IO1),a1		;PSX16x50 UART
		moveq.l	#16-1,d7		;ő16Ch.
chkpsx_loop:
		lea.l	(15,a1),a0		;PSX16x50 SCR
		bsr	check_bus_error_byte
		seq.b	d1			;16x50 : $FF
		lea.l	(14,a1),a0		;PSX16750 UCR
		bsr	check_bus_error_byte
		sne.b	d2			;UCR޽װ : $FF
		cmp.b	#$ff,d0
		seq.b	d3			;UCR = $FF  : $FF
		or.b	d2,d3
		bne	@f
		andi.b	#1,d1
@@:		move.b	d1,(a2)+
		lea.l	(16,a1),a1
		dbra	d7,chkpsx_loop

		lea	(psx_uart,a6),a2	;PSX16x50 UART flag area
		lea	(a2),a1
		lea	(14,a2),a4
		lea	(a4),a2
		moveq.l	#1,d5
		st.b	-(a7)
chkpsx16750_loop:
		cmp.b	(a2),d5
		bne	@f
		cmp.b	1(a2),d5
		bne	@f
		cmp.l	a4,a2			;ID7̏ꍇ͘A2ch݂łȂ
		beq	1f
		cmp.b	2(a2),d5
		bne	@f
		cmp.b	3(a2),d5
		beq	2f
1:
		cmp.b	-1(a2),d5
		beq	@f
		cmp.b	-2(a2),d5
		beq	@f
2:
		move.l	a2,d6
		sub.l	a1,d6
		lsr.b	#1,d6
		move.b	d6,-(a7)
		subq.w	#2,a2
@@:
		subq.w	#2,a2
		cmpa.l	a1,a2
		bcc	chkpsx16750_loop

		clr.b	d1
		lea.l	(psx16750_title,pc),a1
		STRCPY	a1,a5
@@:
		move.b	(a7)+,d0
		cmpi.b	#$ff,d0
		beq	psx_end
		tst.b	d1
		beq	1f
		exg.l	a5,a0
		bsr	strcpy_slash
		exg.l	a5,a0
1:		st.b	d1
		move.b	#'I',(a5)+
		move.b	#'D',(a5)+
		move.b	#'0',(a5)
		add.b	d0,(a5)+
		bra	@b
psx_end:
		tst.b	d1
		beq	psx_not_install
		lea.l	(psx_install,pc),a1
		bra	@f
psx_not_install:
		tst.b	(opt_all_flag,a6)
		beq	print_psx16750_end
		lea.l	(psx_notinstall,pc),a1
@@:		STRCPY	a1,a5

		bsr	print_stack_buffer
print_psx16750_end:
		lea	(256,sp),sp
		rts


psx16750_title:	.dc.b	'PSX16750		:	',0
psx_install:	.dc.b	' installed',CRLF,0
psx_notinstall:	.dc.b	'not install',CRLF,0
		.even


*
*				I/O {[h\(ID 1)				   
*
* obt@̃|C^a2gĂ̂Œӂ邱ƁI

print_board1:
		lea	(-256,sp),sp
		lea	(sp),a2
		moveq	#'1',d0
		bsr	print_board_init

		lea	(FAX_IO+1),a0		;FAX
		lea	(board_fax,pc),a1
		jsr	(a3)

		lea	(MIDI1_IO+1),a0		;MIDI
		lea	(board_midi,pc),a1
		jsr	(a3)

		lea	(PARA1_IO+1),a0		;Parallel
		lea	(board_para,pc),a1
		jsr	(a3)

		lea	(GPIB_IO+1),a0		;GP-IB
		lea	(board_gpib,pc),a1
		jsr	(a3)

		bsr	is_xellent30		;Xellent(ID0,1,2)AWESOME-X͋s
		cmpi.b	#3,d0
		bcs	@f			;Carry ClearȂ狤ł(3or$FFFFFFFF)

		lea	$EC2000,a0		;AWESOME-X
		lea	(board_awe,pc),a1
		jsr	(a3)

@@:
		lea	(RS_IO1+9),a0		;SHARP extend RS232C
		lea	(board_rs,pc),a1
		jsr	(a3)

		bsr	is_xellent30		;Xellent ID3Neptune͋s
		cmp.b	#3,d0
		beq	@f

		lea	(NEPTUNE_IO1+$3ff),a0	;Neptune-X/Evolution
		lea	(board_nep,pc),a1
		jsr	(a3)

@@:
		bsr	is_exist_mercury_unit
		tst.l	d0
		beq	print_board1_no_mu
		bsr	check_mercury_unit	;V3.5ȊO
		bne	1f
		bmi	1f			;gp?
		lea	(board_merc35,pc),a1	;Mercury-Unit v3.5
		bra	10f
1:
		lea	(board_merc,pc),a1	;Mercury-Unit
10:
		subq.l	#MERC_V4,d0
		bcs	@f
		lea	(board_mkmu1,pc),a1	;MK-MU1
		beq	@f
		lea	(board_mkmu1o,pc),a1	;MK-MU1O
@@:
		bsr	print_board_sub_exist
print_board1_no_mu:

		bsr	is_exist_ts6bga
		tst.l	d0
		bne	@f
		lea	(board_bga,pc),a1
		bsr	print_board_sub_exist

@@:		tst.l	d0
		bpl	@f			;s\炵...

		lea	(POLY1_IO+$3c),a0	;POLYPHON
		lea	(board_poly,pc),a1
		bsr	print_board_subw

		lea	(board_psx,pc),a1
		cmpi.b	#-1,(psx_uart,a6)
		bne	3f
		bsr	print_board_sub_exist
		bra	@f
3:
		bsr	2f
@@:
		bra	print_board_end

;	Mercury-Unit̃o[W𒲂ׂ.
;	N : 1ȂMercury-Unitgp
;	Z : 0Ȃ v3.5 1Ȃ炻ȊO
;	܂, !N && Z Ȃ v3.5

check_mercury_unit:
		movem.l	d0-d1/a5-a6,-(a7)
		lea.l	$ecc091,a5		;COMMAND PORT
		lea.l	($10,a5),a6		;STATUS PORT
		btst.b	#7,(a6)			;ꉞǂł݂
		beq	end_mu
		move.l	$e8408c,d1		;DMAC CH2 MAR
		cmp.l	#$ecc080,d1
		seq	d1
		move.l	$e84094,d0		;DMAC CH2 DAR
		cmp.l	#$ecc080,d0
		seq	d0
		or.b	d0,d1			;ǂ炩PCMĐ|[gĂ??
		beq	@f
		btst.b	#3,$e84080		;DMAC CH2]H
		bne	use_mu			;]Ȃ猟Ȃ(Ŝ)
@@:
		move.b	(a5),d0
		move.b	d0,d1
		andi.b	#$7F,d0
		move.w	SR,-(a7)
		ori.w	#$0700,SR		;݋֎~(Ŝ)
		move.b	d0,(a5)			;g؂ւ.
		move.b	(a6),d0			;Xe[^Xǂݏo.
		move.b	d1,(a5)			;gɖ߂.
		move.w	(a7)+,SR		;݋
		btst.l	#7,d0
end_mu:
		movem.l	(a7)+,d0-d1/a5-a6
		rts
use_mu:
		moveq.l	#-1,d0
		bra	end_mu

*
*				I/O {[h\(ID 2)				   
*
* obt@̃|C^a2gĂ̂Œӂ邱ƁI

print_board2:
		lea	(-256,sp),sp
		lea	(sp),a2
		moveq	#'2',d0
		bsr	print_board_init

		lea	(MIDI2_IO+1),a0		;MIDI
		lea	(board_midi,pc),a1
		jsr	(a3)

		lea	(PARA2_IO+1),a0		;Parallel
		lea	(board_para,pc),a1
		jsr	(a3)

		lea	(RS_IO2+9),a0		;SHARP extend RS232C
		lea	(board_rs,pc),a1
		jsr	(a3)

		bsr	is_xellent30		;Xellent ID3Neptune͋s
		cmp.b	#3,d0
		beq	@f

		lea	(NEPTUNE_IO2+$3ff),a0	;Neptune-X/Evolution
		lea	(board_nep,pc),a1
		jsr	(a3)

@@:
		bsr	is_exist_ts6bga
		cmpi.w	#1,d0
		bne	@f
		lea	(board_bga,pc),a1
		bsr	print_board_sub_exist

@@:		tst.l	d0
		bpl	@f			;s\炵...

		lea	(POLY2_IO+$3c),a0	;POLYPHON
		lea	(board_poly,pc),a1
		bsr	print_board_subw

		move.b	(psx_uart+2,a6),d0
		bpl	@f			; ID1:16750ID2:16550͋s

		lea	(board_psx,pc),a1
		bsr	print_board_sub_exist
@@:
print_board_end:
		lea	(crlf,pc),a1
		tst.b	d7
		bne	@f
		tst.b	(opt_all_flag,a6)
		beq	print_board1_skip	;{[hȂȂ\Ȃ
		lea	(not_install,pc),a1
@@:
		STRCPY	a1,a2
		bsr	print_stack_buffer
print_board1_skip:
		lea	(256,sp),sp
		rts

*
*				I/O {[h\(ID 3)				   
*
* obt@̃|C^a2gĂ̂Œӂ邱ƁI

print_board3:
		lea	(-256,sp),sp
		lea	(sp),a2
		moveq	#'3',d0
		bsr	print_board_init

		lea	(RS_IO3+9),a0		;SHARP extend RS232C
		lea	(board_rs,pc),a1
		jsr	(a3)

		bra	print_board_end

*
*				I/O {[h\(ID 4)				   
*
* obt@̃|C^a2gĂ̂Œӂ邱ƁI

print_board4:
		lea	(-256,sp),sp
		lea	(sp),a2
		moveq	#'4',d0
		bsr	print_board_init

		lea	(RS_IO4+9),a0		;SHARP extend RS232C
		lea	(board_rs,pc),a1
		jsr	(a3)

		bra	print_board_end

print_board_init:
		lea	(board_title,pc),a1
		move.b	d0,(18,a1)
		STRCPY	a1,a2

		moveq	#0,d7
		lea	(print_board_sub,pc),a3
		rts

;
; TS-6BGA 
; in  : nothing
; out : d0.l
;

is_exist_ts6bga:
		move.l	a0,-(sp)
		lea	(TS6BGA_PCMCTRL),a0
		bsr	check_bus_error_byte
		bne	is_exist_ts6bga_false
*is_exist_ts6bga_true:
		lea.l	($EE0000),a0		; TS-6BGA ID1 GRAMAhX
		bsr	check_bus_error_long
		bne	is_exist_ts6bga_0
		moveq.l	#1,d0
		bra	@f
is_exist_ts6bga_0:
		moveq.l	#0,d0
		bra	@f
is_exist_ts6bga_false:
		moveq.l	#-1,d0
@@:		movea.l	(sp)+,a0
		rts


* {[h/\
* in	d0.l	0:{[hȂ 1:{[h(sub2̂)
*	d7.b	0:ȑOɃ{[h\Ȃ $80:
*	a0.l	I/OAhX(sub̂)
*	a1.l	{[hAhX
*	a2.l	obt@AhX
* out	d7.b	0:܂߂ă{[h\Ȃ $80:
* break	d0

*print_board_sub2:
*		tst.l	d0
*		beq	print_board_sub_end
*		bra	print_board_sub_exist
print_board_subw:
		bsr	check_bus_error_word
		bra	@f
print_board_sub:
		bsr	check_bus_error_byte
@@:
2:		bne	print_board_sub_end

print_board_sub_exist:
		tas	d7
		beq	@f
		exg	a0,a2
		bsr	strcpy_slash
		exg	a0,a2
@@:		STRCPY	a1,a2
print_board_sub_end:
		rts


board_title:	.dc.b	'optional board ID 0	:	',0
board_midi:	.dc.b	'MIDI',0
board_para:	.dc.b	'Parallel',0
board_poly:	.dc.b	'POLYPHON',0
board_merc35:	.dc.b	'Mercury-Unit v3.5',0
board_merc:	.dc.b	'Mercury-Unit',0
board_mkmu1:	.dc.b	'MK-MU1',0
board_mkmu1o:	.dc.b	'MK-MU1O',0
board_fax:	.dc.b	'FAX',0
board_gpib:	.dc.b	'GP-IB',0
board_psx:	.dc.b	'PSX16550',0
board_awe:	.dc.b	'AWESOME-X',0
board_rs:	.dc.b	'RS-232C',0
board_nep:	.dc.b	'Neptune-X',0
board_bga:	.dc.b	'TS-6BGA',0
		.even


*
*				vZbTx					   
*

print_processor_pfm:
		pea	(proc_title,pc)
		DOS	_PRINT
		addq.l	#4,sp
		bsr	print_wait_message

		bsr	count_processor_speed
		lea	(percent_as,pc),a1
		moveq.l	#1,d7
		bra	print_performance

* xv
* out	d0.l	[v
*	d1.l	10MHz׎̃[v

count_processor_speed:
		PUSH	d2-d6/a0-a5

		lea.l	alarm_work(pc),a3
		move.l	(ALARM_VEC*4),2(a3)
		lea	(count_processor_speed_int,pc),a0
		move.l	a0,(ALARM_VEC*4)

		lea	(RTC),a4
		lea	(MFP-RTC,a4),a5
		moveq	#0,d6

		bset	d6,(~MFP_IMRB,a5)	;荞݋
		sne	(a3)			;ȑO狖Ăset
		bset	d6,(~MFP_IERB,a5)
		sne	1(a3)
	.ifdef	__STOP_TIMER_C__
		bclr	#5,(~MFP_IMRB,a5)	;׌vp
	.endif
		move.b	(~RTC_MODE,a4),d0
		move.b	d0,-(sp)
		bsr	rtc_wait
		move.b	(~RTC_RESET,a4),-(sp)
		bsr	rtc_wait

		move.b	#0,(~RTC_MODE,a4)	;bank select
		bsr	rtc_wait

		move.b	#$c,(~RTC_MODE,a4)	;alarm off
		bsr	rtc_wait

		move.b	#%0100,(~RTC_RESET,a4)	;1Hz on
		bsr	rtc_wait

		move.b	#8,(~RTC_MODE,a4)	;alarm on

		suba.l	a1,a1
		lea	(int_flag,a6),a0
		pea.l	abort(pc)
		move.w	#$FFF2,-(a7)
		DOS	_INTVCS
		addq.w	#6,a7
		move.l	d0,6(a3)
		moveq	#0,d0
		moveq.l	#31,d4			;interrupt flag bit position
		moveq.l	#0,d3			;dummy work for ADDX instruction
		moveq.l	#0,d2			;work for carry flag
		move.w	d3,CCR			;Xflag clear
		bclr.l	d4,d3
@@:
		bclr.l	d4,d3
		beq	@b			;荞ݔ܂őҋ@
count_processor_speed_loop:
	.ifndef	__SHORT_LOOP__
		tst.l	(a1)+			;12
		move.l	a1,d1			;4
		andi.l	#16*1024-1,d1		;16
		movea.l	d1,a1			;4
;v62clk
;10MHz=10000000Hz(clk)
;10MHz/62clk = 161290.32258065
	.endif
		addq.l	#1,d0			;8
		addx.l	d3,d2			;8
		bpl	count_processor_speed_loop ;10
;v26clk
;10MHz/26clk = 384615.38461538

		move.b	(sp)+,(~RTC_RESET,a4)
		bsr	rtc_wait
		move.b	(sp)+,(~RTC_MODE,a4)

	.ifdef	__STOP_TIMER_C__
		bset	#5,(~MFP_IMRB,a5)	;׌vp
	.endif
		tst.b	(a3)
		bne	@f
		bclr	d6,(~MFP_IERB,a5)
@@:		tst.b	1(a3)
		bne	@f
		bclr	d6,(~MFP_IMRB,a5)
@@:
		move.l	2(a3),(ALARM_VEC*4)

		move.l	d0,-(a7)
		move.l	6(a3),-(a7)
		move.w	#$FFF2,-(a7)
		DOS	_INTVCS
		addq.w	#6,a7
		move.l	(a7)+,d0

	.ifdef	__SHORT_LOOP__
		move.l	#384615,d1		;v26clk̏ꍇ
;		move.l	#374145,d1		;l(-2.72%)
	.else
		move.l	#161290,d1		;v62clk̏ꍇ
;		move.l	#158728,d1		;l(-1.58%)
	.endif

		bclr.l	d4,d2			;interrupt flag clear.
		move.l	d2,(carry,a6)		;オ蕪ۑ

		POP	d2-d6/a0-a5
		rts

rtc_wait:
		RTC_WAIT
		rts

alarm_work:
		.dc.b	0,0
		.dc.l	0
		.dc.l	0
abort:
		tst.b	(a3)
		bne	@f
		bclr.b	#0,(~MFP_IERB,a5)
@@:		tst.b	1(a3)
		bne	@f
		bclr.b	#0,(~MFP_IMRB,a5)
@@:
		move.l	2(a3),(ALARM_VEC*4)
		DOS	_EXIT

count_processor_speed_int:
		bset.l	#31,d3
		rte


*
*				vZbTI/Ox				   
*

print_system_pfm:
		moveq	#-1,d7			;
		pea	(syspfm_title,pc)
		bra	@f
print_machine_pfm:
		moveq	#0,d7			;L
		pea	(machine_title,pc)
@@:
		DOS	_PRINT
		addq.l	#4,sp
		bsr	print_wait_message

		bsr	count_system_speed
		lea	(percent,pc),a1
print_performance:
		move.l	d0,-(sp)
		move.l	d1,d0			;10MHz׎̃[v
		FPACK2	__LTOD
		move.l	d0,d4
		move.l	d1,d5			; d4d5 = 10MHzٰ߉

		moveq.l	#0,d0
		move.w	(a7),d0			; d0ʃ[hdouble
		FPACK2	__LTOD
		move.l	d0,d2
		move.l	d1,d3

		move.l	#65536,d0
		FPACK2	__LTOD
		move.l	d0,d6
		move.l	d1,d7
		FPACK2	__DMUL
		move.l	d0,d2
		move.l	d1,d3			; d2d3 = [v񐔏16bit
		moveq.l	#0,d0
		move.w	2(a7),d0
		FPACK2	__LTOD			; d0d1 = [v񐔉16bit
		FPACK2	__DADD
		move.l	d0,d2
		move.l	d1,d3			; d2d3 = [v

		moveq.l	#100,d0
		FPACK2	__LTOD
		FPACK2	__DMUL			; d0d1 = [vx100

		move.l	(carry,a6),d2
		beq	@f

		movem.l	d0/d1,-(a7)

		move.l	d2,d0
		FPACK2	__LTOD			; d0d1 = [v񐔌オ蕪

		move.l	d6,d2
		move.l	d7,d3			; d2d3 = 65536

		FPACK2	__DMUL

		move.l	d6,d2
		move.l	d7,d3			; d2d3 = 65536

		FPACK2	__DMUL			; d0d1 = carry*65536^2
		move.l	d0,d2
		move.l	d1,d3
		movem.l	(a7)+,d0/d1
		FPACK2	__DMUL			; d0d1 = ٰ߉x100x(carry*65536^2)
@@:
		move.l	d4,d2
		move.l	d5,d3

		FPACK2	__DDIV			;(n/n0)*100(%)
		addq.w	#4,a7

		lea	(-256,sp),sp
		lea	(sp),a0

		moveq	#3,d2			;̌
		moveq	#2,d3			;V
		moveq	#0,d4			;ϊIvV
		FPACK2	__USING			;"xxx.xx"̌`ɕϊ
@@:		tst.b	(a0)+
		bne	@b
		subq.l	#1,a0
		STRCPY	a1,a0			;"%"or"% as ..."

		bsr	print_stack_buffer
		lea	(256,sp),sp
		rts

* xv
* in	d7.l	0:ׂ(荞݋)Ōv -1:ׂȂ(荞݋֎~)Ōv
* out	d0.l	[v
*	d1.l	10MHz׎̃[v

count_system_speed:
		PUSH	d2-d6/a0-a5
		move	sr,d6
		move	sr,d5
		tst	d7
		beq	@f
		ori	#$700,d5
@@:
		moveq	#0,d0
		lea	(RTC),a5
		move.b	(~RTC_MODE,a5),-(sp)
		bsr	rtc_wait
		move.b	#%1000,(~RTC_MODE,a5)	;bank 0
		bsr	rtc_wait

		lea	(~RTC_1SEC,a5),a0
		move.b	(a0),d1
@@:		cmp.b	(a0),d1			;bJE^ƓƂ
		beq	@b
		move	d5,sr

		move.b	(a0),d1
@@:		addq.l	#1,d0
		cmp.b	(a0),d1
		beq	@b

		move	d6,sr
		move.b	(sp)+,(~RTC_MODE,a5)

		move.l	#351472,d1		;l
		POP	d2-d6/a0-a5
		rts


print_wait_message:
		moveq	#-1,d1			;\Fۑ
		IOCS	_B_COLOR
		move	d0,-(sp)
		moveq	#WAIT_COLOR,d1		;\Fݒ
		IOCS	_B_COLOR

		move	#STDERR,-(sp)		;"Wait.."\
		pea	(wait_mes,pc)
		DOS	_FPUTS
		addq.l	#6,sp

		move	(sp)+,d1		;\FA
		IOCS	_B_COLOR
		rts


proc_title:	.dc.b	'processor performance	:	',0
syspfm_title:	.dc.b	'system    performance	:	',0
machine_title:	.dc.b	'machine   performance	:	',0
percent_as:	.dc.b	'% as compared with X68000 XVI 10MHz',CRLF,0
percent:	.dc.b	'%',CRLF,0

*wait_mes:	.dc.b	ESC,'[31mWait..',ESC,'[6D',ESC,'[33m',0
*wait_mes:	.dc.b	ESC,'[31mWait..',BS,BS,BS,BS,BS,BS,ESC,'[33m',0
wait_mes:	.dc.b	'Wait..',BS,BS,BS,BS,BS,BS,0
		.even


*
*                              ėpvg[`                              
*

print_crlf:
		pea	(crlf,pc)
		bra	@f
print_stack_buffer:
		pea	(4,sp)
@@:		DOS	_PRINT
		addq.l	#4,sp
		rts


*
*                              -f-ms / -f-memf                                   
*

sw_f_memory_size:
		bsr	get_memory_size
		swap	d0
		lsr	#4,d0			;1024K
		bra	@f

sw_f_memory_free:
		bsr	get_memory_free_size
		lsr.l	#8,d0
		lsr.l	#2,d0			;1024
@@:
		move	d0,-(sp)
		DOS	_EXIT2


*
*                                 -f-cs                                          
*

sw_f_clock_switch:
		moveq	#%1111_0000,d0
		or.b	(SYS_P6),d0
		not	d0
		move	d0,-(sp)
		DOS	_EXIT2


*
*                                -f-fpu                                          
*

sw_f_fpu:
		bsr	get_fpu_type
		move	d0,-(sp)
		DOS	_EXIT2


*
*                               -f-mpu                                           
*

sw_f_mpu:
		bsr	mputype_check
		move	d0,-(sp)
		DOS	_EXIT2


*
*                                   -f-mmu                                       
*

sw_f_mmu:
		bsr	check_mmu
		tst.b	d0
		beq	sw_f_mmu_true
sw_f_mmu_false:
		DOS	_EXIT


*
*                                -f-midi                                         
*

sw_f_midi:
		lea	(MIDI1_IO),a0
		bsr	check_bus_error_byte
		beq	sw_f_midi_true
		lea	(MIDI2_IO-MIDI1_IO,a0),a0
		bsr	check_bus_error_byte
		beq	sw_f_midi_true
*sw_f_midi_false:
		DOS	_EXIT
sw_f_mmu_true:
sw_f_midi_true:
sw_f_mercury_true:
		move	#1,-(sp)
		DOS	_EXIT2


*
*                                 -f-merc                                        
*

sw_f_mercury:
		bsr	is_exist_mercury_unit
		move	d0,-(sp)
		DOS	_EXIT2


* Mercury-Unit ݂邩ׁA݂Ȃ炻̎ނԂ.
* Xellent30 ID:3݂ꍇ́AI/O AhXԂ̂ŐΑ݂Ȃ.
* V3.5ȑO͎gɐݒł邩ǂ𒲂ׂΉ\A
* Đς獢̂ŒׂȂ.
* out	d0.l	0:݂Ȃ
*		1:Mercury-Unit `V3.5
*		2:Mercury-Unit V4.x(MK-MU1)
*		3:Mercury-Unit V4.x with OPN3-L(MK-MU1O)

MERC_V3:	.equ	1
MERC_V4:	.equ	2
MERC_V4OPNA:	.equ	3

is_exist_mercury_unit:
		move.l	a0,-(sp)
		bsr	is_xellent30
		cmp.b	#3,d0
		beq	is_exist_mercury_unit_false

		lea	(MU_STAT),a0
		bsr	check_bus_error_byte
		bne	is_exist_mercury_unit_false

		lea	(MU_TOP-MU_STAT,a0),a0
		bsr	check_bus_error_byte
		bne	is_exist_mercury_unit_v4

		moveq	#MERC_V3,d0
		bra	is_exist_mercury_unit_end

is_exist_mercury_unit_v4:
		move	sr,-(sp)
		ori	#$0700,sr
		st	(MU_OPNREG-MU_TOP,a0)
		bsr	rtc_wait
		move.b	(MU_OPNST2-MU_TOP,a0),d0	;Xe[^XWX^2ǂݍ
		move	(sp)+,sr
		subq.b	#1,d0
		subq.b	#2,d0
		bcs	@f			;1`2ȂOPNAL
		moveq	#MERC_V4,d0
		bra	is_exist_mercury_unit_end
@@:		moveq	#MERC_V4OPNA,d0
		bra	is_exist_mercury_unit_end

is_exist_mercury_unit_false:
		moveq	#0,d0
is_exist_mercury_unit_end:
		movea.l	(sp)+,a0
		rts


*		V3	V4	Xellent30
* $ecc000		~	
* $ecc080			
* $ecc100	~	~	


*
*                              SCSIڑ@\                                  
*

INQBUF_SIZE:	.equ	256

		.offset	0
~scsi_strbuf:	.ds.b	256
~scsi_inqbuf:	.ds.b	INQBUF_SIZE
sizeof_scsi_work:
		.text

print_scsi_info:
		bsr	get_scsi_iocs_level
		move.l	d0,d7
		bpl	@f

		pea	(no_scsi_mes,pc)
		DOS	_PRINT
		addq.l	#4,sp
		move	#1,-(sp)
		DOS	_EXIT
@@:
		andi.b	#8,(is_id15,a6)
		ori.b	#7,(is_id15,a6)
		addq.b	#1,(is_id15,a6)
		lea	(-sizeof_scsi_work,sp),sp
		bsr	print_crlf

		moveq	#0,d4
print_scsi_info_loop:
		lea	(~scsi_strbuf,sp),a0
		move.w	#'ID',(a0)+
		cmpi.b	#10,d4
		bcc	1f
		move.b	d4,d0
		add.b	#'0',d0
		rol.w	#8,d0
		move.b	#' ',d0
		move.w	d0,(a0)+
		bra	@f
1:
		move.l	d4,d0
		divu.w	#10,d0
		add.b	#'0',d0
		move.b	d0,(a0)+
		swap.w	d0
		add.b	#'0',d0
		move.b	d0,(a0)+
@@:
		lea	(scsi_vendor,pc),a1
		STRCPY	a1,a0

		move.b	(SRAM_SCSI_ID),d0
		andi.b	#7,d0
		cmp.b	d0,d4
		beq	print_scsi_info_initiator
		addq.b	#8,d0
		cmp.b	d0,d4
		beq	print_scsi_info_initiator

		lea	(~scsi_inqbuf,sp),a1
		moveq	#0,d0
		moveq	#INQBUF_SIZE/8-1,d1
@@:		move.l	d0,(a1)+
		move.l	d0,(a1)+
		dbra	d1,@b

		lea	(~scsi_inqbuf,sp),a1
		moveq	#5,d3			;Ƃ肠5oCgǂ
		SCSI	_S_INQUIRY
		addq.l	#1,d0
		beq	print_scsi_info_next
		move.b	(4,a1),d3
		beq	no_additional_inquiry
		addq.b	#5,d3			;ǉf[^ǂ
		bcc	@f
		st	d3			;ꉞ255oCg܂...
@@:		SCSI	_S_INQUIRY
		addq.l	#1,d0
		beq	print_scsi_info_next
no_additional_inquiry:
		addq.l	#8,a1			;i
		clr.b	(28,a1)
		STRCPY	a1,a0

		STRCPY_CRLF a0
		bsr	print_stack_buffer

		lea	(~scsi_strbuf,sp),a0
		lea	(scsi_devtype,pc),a1
		STRCPY	a1,a0

		moveq	#0,d0
		move.b	(~scsi_inqbuf+0,sp),d0	;foCX
		cmpi.b	#(pdt_table_end-pdt_table)/2,d0
		bcs	@f
		moveq	#-1,d0
@@:		add	d0,d0
		lea	(pdt_table,pc),a1
		adda	(a1,d0.w),a1
		STRCPY	a1,a0
		bsr	print_stack_buffer

		lea	(~scsi_strbuf,sp),a0
		lea	(scsi_ansi,pc),a1
		STRCPY	a1,a0

		moveq	#%111,d0
		and.b	(~scsi_inqbuf+2,sp),d0	;ANSIKi
		cmpi.b	#(ansi_table_end-ansi_table)/2,d0
		bcs	@f
		moveq	#-1,d0
@@:		add	d0,d0
		lea	(ansi_table,pc),a1
		adda	(a1,d0.w),a1
		STRCPY	a1,a0
		bsr	print_stack_buffer

		lea	(~scsi_strbuf,sp),a0
		lea	(scsi_media,pc),a1
		STRCPY	a1,a0

		tst.b	(~scsi_inqbuf+1,sp)
		smi	d6
		bpl	scsi_not_rmb

		lea	(media_rmb,pc),a1
		STRCPY	a1,a0
scsi_not_rmb:
		lea	(~scsi_inqbuf,sp),a1
		moveq	#0,d2
		moveq	#8,d3
		SCSI	_S_MODESENSE
		addq.l	#1,d0
		beq	scsi_not_writep
		tst.b	(2,a1)
		bpl	scsi_not_writep

		tst.b	d6
		beq	@f
		bsr	strcpy_slash
@@:
		lea	(media_writep,pc),a1
		STRCPY	a1,a0
		st	d6
scsi_not_writep:
		STRCPY_CRLF a0

		tst.b	d6
		beq	@f
		bsr	print_stack_buffer
@@:
		bra	print_scsi_info_next2

print_scsi_info_initiator:
		lea	(vendor_x680x0,pc),a1
		cmpi.b	#$dc,(SYS_P6)
		bne	@f
		move.b	#'3',(12,a1)		;X68030
@@:
		STRCPY	a1,a0

		move.l	a0,a1

		moveq.l	#$1e,d1			;TWOSCSI풓`FbN
		moveq.l	#$f5,d0
		trap	#15

		moveq.l	#-1,d1
		cmp.l	d0,d1
		beq	get_level_no_twoscsi
;get_level_twoscsi:
		move.w	#$020a,d1
		moveq.l	#$f5,d0
		trap	#15
		btst.l	#16,d0
		seq.b	d7
		bra	switch_boardtype
get_level_no_twoscsi:
		btst.b	#3,(SRAM_SCSI_ID)
		sne.b	d7
		SCSI	_S_LEVEL
switch_boardtype:
		lea.l	(-13,a0),a2
		tst.b	d7
		beq	boardtype_internal
		move.b	#'E',(a2)+
		move.b	#'x',(a2)+
		bra	@f
boardtype_internal:
		move.b	#'I',(a2)+
		move.b	#'n',(a2)+
@@:
		moveq.l	#4-1,d2
@@:
		rol.w	#4,d0
		move.b	d0,d1
		andi.b	#15,d1
		cmpi.b	#9,d1
		bcs	1f
		addi.b	#'@'-'0'-9,d1
1:		addi.b	#'0',d1
		move.b	d1,(a0)+
		dbra	d2,@b
		clr.b	(a0)

		move.l	a0,d0
		sub.l	a1,d0			;
		sub.l	d0,a0
		sub.l	d0,a1
		exg	a0,a1
		STRCPY	a1,a0			;28ɂ傤ǎ܂悤...

		STRCPY_CRLF a0
		bsr	print_stack_buffer

		lea	(~scsi_strbuf,sp),a0
		lea	(scsi_devtype,pc),a1
		STRCPY	a1,a0
		lea	(pdt_initiator,pc),a1
		STRCPY	a1,a0
		bsr	print_stack_buffer

print_scsi_info_next2:
		bsr	print_crlf
print_scsi_info_next:
		addq	#1,d4
		cmp.b	(is_id15,a6),d4
		bcs	print_scsi_info_loop

		lea	(sizeof_scsi_work,sp),sp
		DOS	_EXIT

* SCSI IOCS̃x.
* out	d0.l	x(-1ȂSCSIȂ)
;       Atwoscsi삵ĂƂ͈ȉ̂悤ɂȂ.
;       d0.hw	extension SCSI port level.
;       d0.lw	internal  SCSI port level.

get_scsi_iocs_level:
		movem.l	d1-d7/a0-a6,-(a7)
		movem.l	a6/sp,(reg_save,a6)

		clr.b	(is_id15,a6)
		pea	(scsi_iocs_check_trap14,pc)
		move	#TRAP14_VEC,-(sp)
		DOS	_INTVCS
		addq.l	#6,sp
		move.l	d0,(trap14_save,a6)

		moveq.l	#$1e,d1				; TwoSCSI풓`FbN
		moveq.l	#$f5,d0
		trap	#15

		moveq.l	#-1,d1
		cmp.l	d1,d0
		beq	1f				; twoscsiȂȂ
							; ̂܂_S_LEVEL𔭍s

		moveq.l	#-1,d7
		moveq.l	#-2,d1
		cmp.l	d1,d0
		seq.b	d4
		move.b	d4,(is_id15,a6)
		and.w	#8,d4
		beq	2f

		moveq.l	#0,d7

		move.w	#$020a,d1
		moveq.l	#$f5,d0
		trap	#15

		move.l	d0,d5
		clr.w	d4

2:		move.w	#$020a,d1
		moveq.l	#$f5,d0
		trap	#15

		btst.l	#16,d0
		bne	4f
		andi.l	#$FFFF,d0
		bra	3f
4:		swap.w	d0
		clr.w	d0
3:
		tst.l	d7
		bmi	5f
		btst.l	#16,d5
		bne	4f
		andi.l	#$FFFF,d5
		bra	3f
4:		swap.w	d5
		clr.w	d5
3:
		or.l	d5,d0
5:		bra	@f

1:		SCSI	_S_LEVEL
@@:		move.l	d0,-(sp)

		move.l	(trap14_save,a6),-(sp)
		move	#TRAP14_VEC,-(sp)
		DOS	_INTVCS
		addq.l	#6,sp

		move.l	(sp)+,d0
		movem.l	(a7)+,d1-d7/a0-a6
		rts
scsi_iocs_check_trap14:
		movem.l	(work_top+reg_save,pc),a6/sp
		moveq	#-1,d0
		bra	@b


		.dc	pdt_unknown-pdt_table
pdt_table:	.dc	pdt_direct-pdt_table	;$00
		.dc	pdt_sequence-pdt_table	;$01
		.dc	pdt_printer-pdt_table	;$02
		.dc	pdt_processor-pdt_table	;$03
		.dc	pdt_worm-pdt_table	;$04
		.dc	pdt_cdrom-pdt_table	;$05
		.dc	pdt_scanner-pdt_table	;$06
		.dc	pdt_mo-pdt_table	;$07
		.dc	pdt_changer-pdt_table	;$08
		.dc	pdt_com-pdt_table	;$09
pdt_table_end:

		.dc	ansi_unknown-ansi_table
ansi_table:	.dc	ansi_scsi0-ansi_table	;%000
		.dc	ansi_scsi1-ansi_table	;%001
		.dc	ansi_scsi2-ansi_table	;%010
ansi_table_end:


no_scsi_mes:	.dc.b	'SCSI is not installed.',CRLF,0
scsi_vendor:	.dc.b	    ': Vendor Unique Parameter : ',0
scsi_devtype:	.dc.b	'      Peripheral Device Type  : ',0
scsi_ansi:	.dc.b	'      ANSI-Approved Version   : ',0
scsi_media:	.dc.b	'      Medium Type             : ',0

vendor_x680x0:	.dc.b	'SHARP   X68000 Internal     ',0

pdt_initiator:	.dc.b	'initiator',CRLF,0
pdt_unknown:
ansi_unknown:	.dc.b	'unknown',CRLF,0

pdt_direct:	.dc.b	'direct access',CRLF,0
pdt_sequence:	.dc.b	'sequential access',CRLF,0
pdt_printer:	.dc.b	'printer',CRLF,0
pdt_processor:	.dc.b	'processor',CRLF,0
pdt_worm:	.dc.b	'write once memory',CRLF,0
pdt_cdrom:	.dc.b	'read only direct access',CRLF,0
pdt_scanner:	.dc.b	'scanner',CRLF,0
pdt_mo:		.dc.b	'optical memory',CRLF,0
pdt_changer:	.dc.b	'medium changer',CRLF,0
pdt_com:	.dc.b	'communications',CRLF,0

ansi_scsi0:	.dc.b	'Non ANSI',CRLF,0
ansi_scsi1:	.dc.b	'ANSI X3.131-1986   (SCSI-1)',CRLF,0
ansi_scsi2:	.dc.b	'ANSI X3T9.2/86-109 (SCSI-2)',CRLF,0

media_rmb:	.dc.b	'Removable Device',0
media_writep:	.dc.b	'Write Protection',0
		.even


*
*                                荞݃`FbN                                
*

print_interrupt:
		lea	(-256,sp),sp
		lea	(MFP),a3

		bsr	print_int_timer_a
		bsr	print_int_timer_b
		bsr	print_int_timer_c
		bsr	print_int_timer_d
		bsr	print_int_vdisp
		bsr	print_int_hsync
		bsr	print_int_raster
		bsr	print_int_opm
		bsr	print_int_alarm
		bsr	print_int_expon
		bsr	print_int_powsw
		bsr	print_int_printer
		bsr	print_int_sprious

		lea	(256,sp),sp
		DOS	_EXIT

;MFP IERA/IMRA
print_int_timer_a:
		lea	(int_timer_a,pc),a0
		bra	print_int_mfp_a
print_int_timer_b:
		lea	(int_timer_b,pc),a0
		bra	print_int_mfp_a
print_int_hsync:
		lea	(int_hsync,pc),a0
		bra	print_int_mfp_a
print_int_raster:
		lea	(int_raster,pc),a0
		bra	print_int_mfp_a
print_int_mfp_a:
		move.b	(a0)+,d0
		and.b	(~MFP_IERA,a3),d0
		and.b	(~MFP_IMRA,a3),d0
		bra	print_int_en_dis

;MFP IERB/IMRB
print_int_timer_c:
		lea	(int_timer_c,pc),a0
		bra	print_int_mfp_b
print_int_timer_d:
		lea	(int_timer_d,pc),a0
		bra	print_int_mfp_b
print_int_vdisp:
		lea	(int_vdisp,pc),a0
		bra	print_int_mfp_b
print_int_opm:
		lea	(int_opm,pc),a0
		bra	print_int_mfp_b
print_int_alarm:
		lea	(int_alarm,pc),a0
		bra	print_int_mfp_b
print_int_expon:
		lea	(int_expon,pc),a0
		bra	print_int_mfp_b
print_int_powsw:
		lea	(int_powsw,pc),a0
		bra	print_int_mfp_b
print_int_mfp_b:
		move.b	(a0)+,d0
		and.b	(~MFP_IERB,a3),d0
		and.b	(~MFP_IMRB,a3),d0
		bra	print_int_en_dis

print_int_en_dis:
		lea	(int_enable,pc),a1
		bne	print_int_sub
		lea	(int_disable,pc),a1
print_int_sub:
		moveq	#0,d0
		move.b	(a0)+,d0

		lea	(4,sp),a2
		STRCPY	a0,a2			;荞ݖ
		STRCPY	a1,a2			;/֎~

		lea	(crlf,pc),a0
		lsl	#2,d0
		beq	@f			;IOCSŊ荞ݐݒłȂ
		movea.l	d0,a0
		tst.b	(a0)			;AhX̏1oCg
		lea	(int_can_hook,pc),a0
		bne	@f			;!=0Ȃ犄荞ݐݒ\
		lea	(int_cant_hook,pc),a0	;==0Ȃs\
@@:		STRCPY	a0,a2

		bra	print_stack_buffer	;(4,sp) = buffer
*		rts				;bsr(8,sp)ɂȂ̂ŕs

;̑
print_int_printer:
		lea	(int_printer,pc),a0
		btst	#0,(IOC_STATUS)
		bra	print_int_en_dis

print_int_sprious:
		movea.l	(SPRIOUS_VEC*4),a0
		bsr	check_bus_error_word
		lea	(int_sprious,pc),a0
		lea	(spr_notmask,pc),a1
		bne	@f
		cmpi	#RTE_CODE,d0
		bne	@f
		lea	(spr_mask,pc),a1	;rteŖĂ
@@:		bra	print_int_sub


int_timer_a:	.dc.b	1<<5,TIMERA_VEC	,'Timer-A		 :	',0
int_timer_b:	.dc.b	1<<0,0		,'Timer-B		 :	',0
int_timer_c:	.dc.b	1<<5,0		,'Timer-C		 :	',0
int_timer_d:	.dc.b	1<<4,TIMERD_VEC	,'Timer-D		 :	',0
int_vdisp:	.dc.b	1<<6,0		,'V-DISP		 :	',0
int_hsync:	.dc.b	1<<7,HSYNC_VEC	,'H-SYNC		 :	',0
int_raster:	.dc.b	1<<6,RASTER_VEC	,'Raster		 :	',0
int_opm:	.dc.b	1<<3,OPM_VEC	,'OPM		 :	',0
int_alarm:	.dc.b	1<<0,0		,'Alarm		 :	',0
int_expon:	.dc.b	1<<1,0		,'EXPON		 :	',0
int_powsw:	.dc.b	1<<2,0		,'Power Switch	 :	',0
int_printer:	.dc.b	     PRINTER_VEC,'Printer		 :	',0
int_sprious:	.dc.b	     0		,'Sprious		 :	',0
int_enable:	.dc.b	'enable',0
int_disable:	.dc.b	'disable',0
spr_mask:	.dc.b	'masked',0
spr_notmask:	.dc.b	'not masked',0
int_can_hook:	.dc.b	' (can hook)',CRLF,0
int_cant_hook:	.dc.b	' (cannot hook)',CRLF,0
		.even


* gp@\ ---------------------------------- *

print_version:
		pea	(version_mes,pc)
		bra	@f
print_long_help:
		pea	(title_mes,pc)
		DOS	_PRINT
		pea	(usage_mes,pc)
		DOS	_PRINT
		addq.l	#8,sp
		pea	(switch_mes,pc)
@@:		DOS	_PRINT
		addq.l	#4,sp

		DOS	_EXIT

print_short_help:
		lea	(usage_mes,pc),a0
		bra	@f
setblock_error:
		lea	(memory_err_mes,pc),a0
@@:		move	#STDERR,-(sp)
		move.l	a0,-(sp)
		DOS	_FPUTS
		addq.l	#6,sp

		move	#1,-(sp)
		DOS	_EXIT2


* Subroutine ---------------------------------- *

* wAhXǂ݂ŃoXG[邩ׂ.
* in	a0.l	AhX
* out	d0.b	ǂݍ񂾃f[^
*	ccr	Z=1:I Z=0:oXG[

check_bus_error_byte:
		move	#1,-(sp)
		move.l	sp,-(sp)
		move.l	a0,-(sp)
		DOS	_BUS_ERR
		move.l	d0,(sp)
		moveq	#0,d0
		move.b	(8,sp),d0
		tst.l	(sp)+
		addq.l	#10-4,sp
		rts

check_bus_error_word:
		move	#2,-(sp)
		move.l	sp,-(sp)
		move.l	a0,-(sp)
		DOS	_BUS_ERR
		move.l	d0,(sp)
		moveq	#0,d0
		move	(8,sp),d0
		tst.l	(sp)+
		addq.l	#10-4,sp
		rts

check_bus_error_long:
		move	#4,-(sp)
		subq.l	#4,sp
		move.l	sp,(sp)
		move.l	a0,-(sp)
		DOS	_BUS_ERR
		move.l	d0,(sp)
		move.l	(4,sp),d0
		tst.l	(sp)+
		addq.l	#10-4,sp
		rts


* l10iϊ
* in	d0.l	l(ȂAő655359܂)
*	a0.l	obt@
* out	a0.l	+= strlen()
* ̖NUL͂Ȃ.
* ݖgp

	.if	0
num_to_str:
		divu	#10,d0
		beq	num_to_str_last

		move.l	d0,-(sp)
		andi.l	#$ffff,d0
		bsr	num_to_str
		move.l	(sp)+,d0
num_to_str_last:
		swap	d0
		addi.b	#'0',d0
		move.b	d0,(a0)+
		rts
	.endif

* FEfunction call ------------------------------ *

FEcall:
		pea.l	(@f,pc)				;ݱڽɐς
		move.l	$a0,(trap8_save,a6)		;trap #8޸ޔ
		pea.l	(FEcall_trap,pc)		;݃xN^ݒ
		move.l	(a7)+,$a0
		trap	#8				;R[
@@:
		move.l	(trap8_save,a6),$a0		;trap#8޸A
		rts

FEcall_trap:
		move.l	a0,-(a7)
		lea.l	(FEnum,a6),a0
		move.l	a0,2+4(a7)			;^[AhXݒ
		move.l	(a7)+,a0
		move.l	(FLINE_VEC*4),-(a7)		;fline emulator޸ɼެ
		rts


* HUPAIR Decoder ------------------------------ *

GetArgChar:
		movem.l	d1/a0-a1,-(sp)
		moveq	#0,d0
		lea	(GetArgChar_p,a6),a0
		movea.l	(a0)+,a1
		move.b	(a0),d0
		bmi	GetArgChar_noarg
GetArgChar_quate:
		move.b	d0,d1
GetArgChar_next:
		move.b	(a1)+,d0
		beq	GetArgChar_endarg
		tst.b	d1
		bne	GetArgChar_inquate
		cmpi.b	#' ',d0
		beq	GetArgChar_separate
		cmpi.b	#"'",d0
		beq	GetArgChar_quate
		cmpi.b	#'"',d0
		beq	GetArgChar_quate
GetArgChar_end:
		move.b	d1,(a0)
		move.l	a1,-(a0)
GetArgChar_abort:
		movem.l	(sp)+,d1/a0-a1
		rts
GetArgChar_endarg:
		st	(a0)
		bra	GetArgChar_abort
GetArgChar_noarg:
		moveq	#1,d0
		ror.l	#1,d0
		bra	GetArgChar_abort

GetArgChar_inquate:
		cmp.b	d0,d1
		bne	GetArgChar_end
		clr.b	d1
		bra	GetArgChar_next

GetArgChar_separate:
		cmp.b	(a1)+,d0
		beq	GetArgChar_separate
		moveq	#0,d0
		tst.b	-(a1)
		beq	GetArgChar_endarg
		bra	GetArgChar_end

GetArgCharInit:
		movem.l	a0-a1,-(sp)
		movea.l	(12,sp),a1
GetArgCharInit_skip:
		cmpi.b	#' ',(a1)+
		beq	GetArgCharInit_skip
		tst.b	-(a1)
		lea	(GetArgChar_c,a6),a0
		seq	(a0)
		move.l	a1,-(a0)
		movem.l	(sp)+,a0-a1
		rts


* Data Section -------------------------------- *

		.data
		.even

option_f_table1:
		.dc.b	'ms',0			;IvVǉ
		.dc.b	'memf',0		;LONG_OPT_MAXύX邱
*		.dc.b	'hims',0
*		.dc.b	'himemf',0
		.dc.b	'cs',0
		.dc.b	'fpu',0
		.dc.b	'mpu',0
		.dc.b	'mmu',0
		.dc.b	'midi',0
		.dc.b	'merc',0
		.dc.b	0
		.even
option_f_table2:
		.dc	sw_f_memory_size-$
		.dc	sw_f_memory_free-$
*		.dc	sw_f_hims-$
*		.dc	sw_f_himemf-$
		.dc	sw_f_clock_switch-$
		.dc	sw_f_fpu-$
		.dc	sw_f_mpu-$
		.dc	sw_f_mmu-$
		.dc	sw_f_midi-$
		.dc	sw_f_mercury-$

long_opt_table1:
		.dc.b	'all',0			;IvVǉ
		.dc.b	'cut',0			;LONG_OPT_MAXύX邱
		.dc.b	'help',0
		.dc.b	'int',0
		.dc.b	'power',0
		.dc.b	'scsi',0
		.dc.b	'version',0
		.dc.b	0
		.even
long_opt_table2:
		.dc	option_all-$
		.dc	option_cut-$
		.dc	print_long_help-$
		.dc	print_interrupt-$
		.dc	option_power-$
		.dc	print_scsi_info-$
		.dc	print_version-$


* f[^ -------------------------------- *

version_mes:
		.dc.b	CRLF
		.dc.b	' System Information (Si)',CRLF
		.dc.b	' Modified Version ',version,CRLF
		.dc.b	CRLF
		.dc.b	'Copyright (C) 1992-1993 , Misao.Satake',CRLF
		.dc.b	'Copyright (C) 1993-1997 , Tatsuya.Tsuyuzaki',CRLF
		.dc.b	'Copyright (C) 1997      , Arisugawa Seara',CRLF
		.dc.b	'Copyright (C) 1997      , syo',CRLF
		.dc.b	CRLF
		.dc.b	0
title_mes:
		.dc.b	CRLF
		.dc.b	'X680x0 System Information Version ',version,CRLF
		.dc.b	0
usage_mes:
		.dc.b	'usage : si [-i,-a,-c,-p,-s,-f-(ms,memf,cs,fpu,mpu,mmu,midi,merc)]',CRLF
		.dc.b	0
switch_mes:
		.dc.b	'switch:',CRLF
		.dc.b	'	-a  --all	all device',CRLF
		.dc.b	'	-c  --cut	cut benchmark',CRLF
		.dc.b	'	-i  --int	check interrupts',CRLF
		.dc.b	'	-p  --power	benchmark only',CRLF
		.dc.b	'	-s  --scsi	SCSI check',CRLF
		.dc.b	'	-v  --version	print version',CRLF
		.dc.b	CRLF
		.dc.b	'	-f-ms		Memory Size (Mbytes)',CRLF
		.dc.b	'	-f-memf		Free Area (Kbytes)',CRLF
		.dc.b	'	-f-cs		Clock Switch',CRLF
		.dc.b	'	-f-fpu		Floating Point Unit',CRLF
		.dc.b	'	-f-mpu		Micro Processing Unit',CRLF
		.dc.b	'	-f-mmu		Memory Managemant Unit',CRLF
		.dc.b	'	-f-midi		MIDI',CRLF
		.dc.b	'	-f-merc		Mercury-Unit',CRLF
crlf:		.dc.b	CRLF
		.dc.b	0

memory_err_mes:	.dc.b	'si: setblock failed.',CRLF,0

rcsID:		.dc.b	'$Id: si.s,v 1.3 1997/09/29 21:04:47 Syo Exp $',0

		.even


* Block Storage Section ----------------------- *

		.bss
		.even
work_top:


		.end	si_start

* End of File --------------------------------- *
